//---------------------------------------------------------------------------

#ifndef EngineRequestH
#define EngineRequestH

#include <stdexcep.h>
#include <string>
#include "RuntimeConsole.h"
#include "ErrorDlg.h"
#include "SocketObj.h"
#include "CodeEditor.h"
#include "TransFlow.h"
#include "RuntimeConsole.h"


//---------------------------------------------------------------------------
class EngineRequest
{
 public:
        EngineRequest(SocketObj *s);
        EngineRequest();
        ~EngineRequest();

        void Request(NameValueTyp &r)throw(exception);
        void LockEngine() throw(exception);
        void GetEngineStatus() throw(exception);
        void GetTransactionModels() throw(exception);
        void ListConnectors() throw(exception);
        void ListTransformers() throw(exception);
        void GetFailedTransactions() throw(exception);
        void UnlockEngine() throw(exception);
        void GetTransCode(string transName, TMemo *memo) throw(exception);
        void SaveTransCode(TMemo *memo) throw(exception);
        void GetConfigValues(TListItem *item, TAdvStringGrid *strG) throw(exception);
        void GetConfigValues(string servletName, TAdvStringGrid *strG) throw(exception);
        void SetParam(string servletName, string paramName, string paramValue) throw(exception);
        void GetPhaseData(string transId, string phaseNumber) throw(exception);
        void GetRecoveryPoints(string transId, string lastPoint) throw(exception);
        void GetTransSchema(string transName) throw(exception);
        void DeleteFailedTransaction(string transName) throw(exception);
        void Refresh() throw(exception);
        void StopEngine() throw(exception);
        void StartEngine() throw(exception);
        void SetConsoleParam(NameValueTyp &params) throw(exception);
        void SuspendModel(string modelName) throw(exception);
        void ActivateModel(string modelName) throw(exception);
        void DeleteModel(string modelName) throw(exception);
        void RunRecovery(string transId, string transPhase) throw(exception);
        void SetPhaseData(string transId, string transPhase, NameValueTyp &params) throw(exception);
        void ListBizProc() throw(exception);
        void StartServlet(string servletName) throw(exception);
        void StopServlet(string servletName) throw(exception);

 private:
        string          codeFileName;
        TListItem       *ListItem;
        char            ndx[256];
        //SocketObj       &s;
        SocketObj       *s;
        NameValueTyp    r;
};

class RecoveryInfo : public TObject
{
 public:
        string  phaseNumber;
        string  failedServlet;
        string  timeStamp;
        string  transId;
};


#endif
