//---------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "RuntimeConsole.h"
#include "SocketObj.h"
#include "ErrorDlg.h"
#include "CodeEditor.h"
#include "EngineRequest.h"
#include "TransFlow.h"


//---------------------------------------------------------------------
#pragma link "AdvGrid"
#pragma link "treelist"
#pragma link "Animate"
#pragma link "GIFCtrl"
#pragma link "BaseGrid"
#pragma resource "*.dfm"
TPagesDlg *PagesDlg;


//---------------------------------------------------------------------
__fastcall TPagesDlg::TPagesDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------

void __fastcall TPagesDlg::Button6Click(TObject *Sender)
{
 extern EngineRequest *er;

        if (Button6->Caption == "Stop Engine")
        {
                try {
                        er->StopEngine();
                } catch (Exception &exception){
                        Application->ShowException(&exception);
                } catch (exception const &msg) {
                        ErrorDlg1->Label1->Caption = AnsiString("Stop Engine " +
                                AnsiString(msg.what()));
                        ErrorDlg1->ShowModal();
                }
        }
        else
        {
                try {
                        er->StartEngine();
                } catch (Exception &exception){
                        Application->ShowException(&exception);
                } catch (exception const &msg) {
                        ErrorDlg1->Label1->Caption = AnsiString("Start Engine " +
                                AnsiString(msg.what()));
                        ErrorDlg1->ShowModal();
                }
        }
}

//---------------------------------------------------------------------------

void __fastcall TPagesDlg::CheckBox6Click(TObject *Sender)
{
        PagesDlg->CheckBox6->Checked = SetItem(Encryption);
}

//---------------------------------------------------------------------------
bool __fastcall TPagesDlg::SetItem(ItemNameEnum itm)
{
 NameValueTyp r;
 bool savedValue;

        r["sysClientId"] = "RuntimeMonitor";
        r["sysRequest"] = "Set Console Param";
        r["sysReply"] = "True";
        r["sysDebug"] = "True";
        switch (itm)
        {
                case Encryption :
                r["sysParam"] = "Encryption";
                savedValue = PagesDlg->CheckBox6->Checked;
                r["sysValue"] = PagesDlg->CheckBox6->Checked == true ? "True" : "False";
                break;
                case EMail :
                {
                r["sysParam"] = "EMail";
                savedValue = true;
                std::string str = PagesDlg->Edit2->Text.c_str();
                int i = str.find_last_not_of(" \t");
                str.resize(i +1);

                if (!str.length() || !strpbrk(str.c_str(), "@"))
                {
                        ErrorDlg1->Label1->Caption = "ERR: No or invalid email address";
                        ErrorDlg1->ShowModal();
                        return !savedValue;
                }

                r["sysValue"] = str;
                break;
                }
                case TransactionMode :
                savedValue = PagesDlg->CheckBox1->Checked;
                r["sysParam"] = "Transaction Mode";
                r["sysValue"] = PagesDlg->CheckBox1->Checked == true ? "True" : "False";
                break;
                case Persistence :
                savedValue = PagesDlg->CheckBox2->Checked;
                r["sysParam"] = "Audit";
                r["sysValue"] = PagesDlg->CheckBox2->Checked == true ? "True" : "False";
                break;
                case RestartConnectors :
                r["sysParam"] = "Re-start Connectors";
                savedValue = PagesDlg->CheckBox3->Checked;
                r["sysValue"] = PagesDlg->CheckBox3->Checked == true ? "True" : "False";
                break;
                case EmailOnFailure :
                r["sysParam"] = "Email On Failure";
                savedValue = PagesDlg->CheckBox4->Checked;
                r["sysValue"] = PagesDlg->CheckBox4->Checked == true ? "True" : "False";
                break;
                case HaltSystemOnFailure :
                savedValue = PagesDlg->CheckBox5->Checked;
                r["sysParam"] = "Halt On Failure";
                r["sysValue"] = PagesDlg->CheckBox5->Checked == true ? "True" : "False";
                r["sysNumbOfFailures"] = PagesDlg->Edit1->Text.c_str();
                break;
                default: return !savedValue;
        }
        extern EngineRequest *er;
        try {
                er->SetConsoleParam(r);
        } catch (Exception &exception){
                Application->ShowException(&exception);
                return !savedValue;
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Set Config Option " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
                return !savedValue;
        }
        return savedValue;
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::CheckBox1Click(TObject *Sender)
{
        PagesDlg->CheckBox1->Checked = SetItem(TransactionMode);
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::CheckBox2Click(TObject *Sender)
{
        PagesDlg->CheckBox2->Checked = SetItem(Persistence);
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::CheckBox3Click(TObject *Sender)
{
        PagesDlg->CheckBox3->Checked = SetItem(RestartConnectors);
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::CheckBox4Click(TObject *Sender)
{
 bool res;

        if (PagesDlg->CheckBox4->Checked)
        {
                res = SetItem(EMail);
                if (res)
                        PagesDlg->CheckBox4->Checked = SetItem(EmailOnFailure);
                else
                        PagesDlg->CheckBox4->Checked = false;
        }
        else
                PagesDlg->CheckBox4->Checked = SetItem(EmailOnFailure);
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::CheckBox5Click(TObject *Sender)
{
        PagesDlg->CheckBox5->Checked = SetItem(HaltSystemOnFailure);
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::Edit2Exit(TObject *Sender)
{
 //       SetItem(EMail);
}
//---------------------------------------------------------------------------



void __fastcall TPagesDlg::Edit2Click(TObject *Sender)
{
//     PagesDlg->CheckBox4->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::Edit1Click(TObject *Sender)
{
     PagesDlg->CheckBox5->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::Edit2Enter(TObject *Sender)
{
     PagesDlg->CheckBox4->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::EditCode1Click(TObject *Sender)
{
 extern EngineRequest *er;

        TGridRect coords = PagesDlg->AdvStringGrid3->Selection;
        string transName = PagesDlg->AdvStringGrid3->Cells[1][coords.Top].c_str();

        try {
                er->GetTransCode(transName.c_str(), Form2->Memo1);
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Get Trans Code " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }

        //Form2->Caption = AnsiString("Editing: ") + r["sysFileName"].c_str();
        Form2->Button1->Caption = "Cancel";
        Form2->Button2->Visible = true;
        Form2->Memo1->ReadOnly = false;
        Form2->Show();
}
//---------------------------------------------------------------------------


void __fastcall TPagesDlg::Button1Click(TObject *Sender)
{
 extern EngineRequest *er;

        er->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::SuspendModel1Click(TObject *Sender)
{
 extern EngineRequest *er;

        TGridRect coords = PagesDlg->AdvStringGrid3->Selection;
        string transName = PagesDlg->AdvStringGrid3->Cells[1][coords.Top].c_str();

        try {
                er->SuspendModel(transName);
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Suspend Model " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }
        PagesDlg->AdvStringGrid3->Selection = coords;
 }
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::DeleteModel1Click(TObject *Sender)
{
 extern EngineRequest *er;

        TGridRect coords = PagesDlg->AdvStringGrid3->Selection;
        string transName = PagesDlg->AdvStringGrid3->Cells[1][coords.Top].c_str();

        try {
                er->DeleteModel(transName);
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Delete Model " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::MaskEdit2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 extern EngineRequest *er;
 extern bool connected;

        if (Key == char(13))
        {
                if (connected)
                {
                        try {
                                er->UnlockEngine();
                                connected = false;
                        //} catch (Exception &exception){
                        //        Application->ShowException(&exception);
                        } catch (exception const &msg) {
                                ErrorDlg1->Label1->Caption = AnsiString("Un-lock Engine " +
                                        AnsiString(msg.what()));
                                ErrorDlg1->ShowModal();
                        }
                }

                delete er;
                er = (EngineRequest *) 0;
                AnsiString oldAddress = ClientSocket1->Address;
                AnsiString oldPort = ClientSocket1->Port;
                if (isdigit(*MaskEdit2->Text.c_str()))
                        ClientSocket1->Address = MaskEdit2->Text;
                else
                        ClientSocket1->Host = MaskEdit2->Text;

                ClientSocket1->Port = atoi(MaskEdit3->Text.c_str());
                try {
                        er = new EngineRequest();
                        er->GetEngineStatus();
                        er->LockEngine();
                        EnableAll();
                        er->Refresh();
                        connected = true;
                } catch (...) {
                        ErrorDlg1->Label1->Caption = AnsiString("Cannot connect to address " +
                                ClientSocket1->Address);
                        ErrorDlg1->ShowModal();
                        DisableAll();
                        connected = false;
 #if 0
                        ClientSocket1->Address = oldAddress;
                        ClientSocket1->Port = atoi(oldPort.c_str());
                        MaskEdit2->Text = oldAddress;
                        MaskEdit3->Text = oldPort;
                        // Attempt to get the old connection back
                        try {
                                if (er) delete er;
                                er = new EngineRequest();
                                er->GetEngineStatus();
                                er->LockEngine();
                                EnableAll();
                                er->Refresh();
                                connected = true;
                        } catch (...) {
                                DisableAll();
                        }
 #endif
                }
        }
}

//---------------------------------------------------------------------------
void __fastcall TPagesDlg::EnableAll()
{
        // enable all
        Button6->Enabled = true;
        Button1->Enabled = true;
        CancelBtn->Enabled = true;
        HelpBtn->Enabled = true;
        CheckBox1->Enabled = true;
        CheckBox2->Enabled = true;
        CheckBox3->Enabled = true;
        CheckBox4->Enabled = true;
        CheckBox5->Enabled = true;
        CheckBox6->Enabled = true;
        Edit2->Enabled = true;
        Edit1->Enabled = true;
        AdvStringGrid3->Enabled = true;
        Label7->Enabled = true;
        Label26->Enabled = true;
}

//---------------------------------------------------------------------------
void __fastcall TPagesDlg::DisableAll()
{
        // disable all

        Button6->Enabled = false;
        Button1->Enabled = false;
        CancelBtn->Enabled = false;
        HelpBtn->Enabled = false;
        CheckBox1->Enabled = false;
        CheckBox2->Enabled = false;
        CheckBox3->Enabled = false;
        CheckBox4->Enabled = false;
        CheckBox5->Enabled = false;
        CheckBox6->Enabled = false;
        Edit2->Enabled = false;
        Edit1->Enabled = false;
        AdvStringGrid3->Enabled = false;
        Label7->Enabled = false;
        Label26->Enabled = false;
}

//---------------------------------------------------------------------------

void __fastcall TPagesDlg::AdvStringGrid1SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
        if (ACol == 0)
                PagesDlg->AdvStringGrid1->Options >> goEditing;
        else
                PagesDlg->AdvStringGrid1->Options << goEditing;
}

//---------------------------------------------------------------------------

void __fastcall TPagesDlg::AdvStringGrid2SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
        if (ACol == 0)
                PagesDlg->AdvStringGrid2->Options >> goEditing;
        else
                PagesDlg->AdvStringGrid2->Options << goEditing;
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::AdvStringGrid2CellValidate(TObject *Sender,
      int Col, int Row, AnsiString &Value, bool &Valid)
{
 extern EngineRequest *er;

        string paramName = PagesDlg->AdvStringGrid2->Cells[0][Row].c_str();
        string paramValue = Value.c_str();

        try {
                er->SetParam(PagesDlg->ListView1->Selected->Caption.c_str(),
                               paramName, paramValue);
        } catch (Exception &exception){
                Application->ShowException(&exception);
                Valid = false;
                return;
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Set Param " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
                Valid = false;
                return;
        }
        Valid = true;
 }
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::AdvStringGrid1CellValidate(TObject *Sender,
      int Col, int Row, AnsiString &Value, bool &Valid)
{
extern EngineRequest *er;

        string paramName = PagesDlg->AdvStringGrid1->Cells[0][Row].c_str();
        string paramValue = Value.c_str();

        try {
                er->SetParam(PagesDlg->ListView3->Selected->Caption.c_str(),
                               paramName, paramValue);
        } catch (Exception &exception){
                Application->ShowException(&exception);
                Valid = false;
                return;
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Set Param " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
                Valid = false;
                return;
        }
        Valid = true;
 }

//---------------------------------------------------------------------------

void __fastcall TPagesDlg::ActivateModel1Click(TObject *Sender)
{
 extern EngineRequest *er;

        TGridRect coords = PagesDlg->AdvStringGrid3->Selection;
        string transName = PagesDlg->AdvStringGrid3->Cells[1][coords.Top].c_str();

        try {
                er->ActivateModel(transName);
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Suspend Model " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }
        PagesDlg->AdvStringGrid3->Selection = coords;
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::Resetfailure1Click(TObject *Sender)
{
 extern EngineRequest *er;

        TListItem *item = ListView2->Selected;
        if (!item) return;

        //AnsiString transId = item->SubItems->Strings[1];
        AnsiString transId = item->Caption;
        if (transId == "") return;

   //TO DO - change to an  ok or cancel box
        ErrorDlg1->Label1->Caption = AnsiString("Are you sure you wish to "
                "reset this failed transaction?\nOnce reset recovery "
                "information will no longer be available");
        ErrorDlg1->ShowModal();

        try {
                er->DeleteFailedTransaction(transId.c_str());
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Delete Failed Trans " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::N3Click(TObject *Sender)
{
        // start the recovery manager
 extern EngineRequest *er;

        TListItem *item = ListView2->Selected;
        if (!item) return;
        AnsiString transId = item->Caption;
        AnsiString transName = item->SubItems->Strings[1];
        AnsiString lastPoint = item->SubItems->Strings[5];
        Form3->StatusBar1->SimpleText = "Failure reason: " + item->SubItems->Strings[3];

        if (transName == "") return;

        try {
                er->GetTransCode(transName.c_str(), Form3->Memo1);
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Get Trans Code " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }

        try {
                er->GetRecoveryPoints(transId.c_str(), lastPoint.c_str());
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Get Recovery Points " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }

        int sel = Form3->ComboBox1->ItemIndex;
        RecoveryInfo *ri = (RecoveryInfo *) Form3->ComboBox1->Items->Objects[sel];
        try {
                er->GetPhaseData(ri->transId, ri->phaseNumber);
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Get Phase Data " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }

        try {
                er->GetTransSchema(transName.c_str());
        } catch (Exception &exception){
                Application->ShowException(&exception);
        } catch (exception const &msg) {
                ErrorDlg1->Label1->Caption = AnsiString("Get Trans Schema " +
                        AnsiString(msg.what()));
                ErrorDlg1->ShowModal();
        }

        Form3->Caption = "Recovering transaction - " + transName;
        //Form3->ShowModal();
        Form3->Show();
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::Start1Click(TObject *Sender)
{
 // Send a request to Run this servlet
 extern EngineRequest *er;

        TListItem *item = ListView1->Selected;
        if (!item || (item->StateIndex == 0)) return;
        AnsiString servletName = item->Caption;
        er->StartServlet(servletName.c_str());
        item->StateIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::Stop1Click(TObject *Sender)
{
// Send a request to Halt this servlet
 extern EngineRequest *er;

        TListItem *item = ListView1->Selected;
        if (!item || (item->StateIndex == 4)) return;
        AnsiString servletName = item->Caption;
        er->StopServlet(servletName.c_str());
        item->StateIndex = 4;
}
//---------------------------------------------------------------------------
TListItem *oldItem = (TListItem *) 0;
void __fastcall TPagesDlg::ListView1Click(TObject *Sender)
{
 extern EngineRequest *er;

        TListItem *item = ListView1->Selected;
        if (!item) return;
        if (item != oldItem)
        {
                er->GetConfigValues(item, AdvStringGrid2);
                oldItem = item;
        }
}
//---------------------------------------------------------------------------
TListItem *oldItem1 = (TListItem *) 0;
void __fastcall TPagesDlg::ListView3Click(TObject *Sender)
{
 extern EngineRequest *er;

        TListItem *item = ListView3->Selected;
        if (!item) return;
        if (item != oldItem1)
        {
                er->GetConfigValues(item, AdvStringGrid1);
                oldItem1 = item;
        }
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::MenuItem1Click(TObject *Sender)
{
 // Send a request to Run this servlet
 extern EngineRequest *er;

        TListItem *item = ListView3->Selected;
        if (!item || (item->StateIndex == 0)) return;
        AnsiString servletName = item->Caption;
        er->StartServlet(servletName.c_str());
        item->StateIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TPagesDlg::MenuItem2Click(TObject *Sender)
{
// Send a request to Halt this servlet
 extern EngineRequest *er;

        TListItem *item = ListView3->Selected;
        if (!item || (item->StateIndex == 4)) return;
        AnsiString servletName = item->Caption;
        er->StopServlet(servletName.c_str());
        item->StateIndex = 4;
}
//---------------------------------------------------------------------------

