//----------------------------------------------------------------------------
#ifndef RuntimeConsoleH
#define RuntimeConsoleH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ScktComp.hpp>
#include <Menus.hpp>
#include <jpeg.hpp>
#include <ImgList.hpp>
#include <Mask.hpp>
#include <Grids.hpp>
#include <Outline.hpp>
#include <AdvGrid.hpp>
#include "treelist.hpp"
#include "Animate.hpp"
#include "GIFCtrl.hpp"
#include "BaseGrid.hpp"

#include <list>
#include <map>
#include <vector>
#include <queue>
#include <string>
//----------------------------------------------------------------------------
typedef std::map< std::string, std::string > NameValueTyp;
enum ItemNameEnum {Encryption, TransactionMode, Persistence, RestartConnectors,
        EmailOnFailure, HaltSystemOnFailure, EMail};
//----------------------------------------------------------------------------
class TPagesDlg : public TForm
{
__published:
	TPanel *Panel2;
	TButton *CancelBtn;
	TButton *HelpBtn;
        TPanel *Panel1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TPanel *Panel3;
        TLabel *Label1;
        TLabel *Label5;
        TLabel *Label2;
        TPanel *Panel4;
        TCheckBox *CheckBox1;
        TCheckBox *CheckBox2;
        TCheckBox *CheckBox3;
        TCheckBox *CheckBox4;
        TEdit *Edit2;
        TCheckBox *CheckBox5;
        TEdit *Edit1;
        TLabel *Label7;
        TPanel *Panel5;
        TLabel *Label12;
        TLabel *Label13;
        TPanel *Panel6;
        TButton *Button6;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label15;
        TLabel *Label14;
        TLabel *Label16;
        TTabSheet *TabSheet4;
        TCheckBox *CheckBox6;
        TClientSocket *ClientSocket1;
        TTimer *Timer1;
        TStatusBar *StatusBar1;
        TPageControl *PageControl2;
        TTabSheet *TabSheet5;
        TTabSheet *TabSheet8;
        TCheckBox *CheckBox7;
        TGroupBox *GroupBox1;
        TListBox *ListBox3;
        TRadioButton *RadioButton2;
        TRadioButton *RadioButton3;
        TRadioButton *RadioButton4;
        TRadioButton *RadioButton5;
        TRadioButton *RadioButton6;
        TEdit *Edit5;
        TLabel *Label19;
        TLabel *Label20;
        TButton *Button1;
        TLabel *Label21;
        TTabSheet *TabSheet9;
        TListView *ListView2;
        TPopupMenu *PopupMenu2;
        TMenuItem *EditCode1;
        TImageList *ImageList1;
        TBevel *Bevel1;
        TStaticText *StaticText1;
        TMaskEdit *MaskEdit2;
        TStaticText *StaticText2;
        TMaskEdit *MaskEdit3;
        TStaticText *StaticText3;
        TButton *Button2;
        TTabSheet *TabSheet10;
        TLabel *Label6;
        TPageControl *PageControl3;
        TTabSheet *TabSheet11;
        TStaticText *StaticText8;
        TStaticText *StaticText9;
        TStaticText *StaticText10;
        TStaticText *StaticText11;
        TLabel *Label8;
        TLabel *Label9;
        TStaticText *StaticText12;
        TStaticText *StaticText13;
        TLabel *Label10;
        TLabel *Label11;
        TEdit *Edit3;
        TEdit *Edit4;
        TStaticText *StaticText5;
        TStaticText *StaticText6;
        TStaticText *StaticText7;
        TStaticText *StaticText14;
        TEdit *Edit7;
        TEdit *Edit8;
        TLabel *Label17;
        TLabel *Label18;
        TLabel *Label22;
        TLabel *Label23;
        TMenuItem *SuspendModel1;
        TMenuItem *DeleteModel1;
        TLabel *Label24;
        TLabel *Label25;
        TTabSheet *TabSheet3;
        TTabSheet *TabSheet6;
        TAdvStringGrid *AdvStringGrid2;
        TComboBox *ComboBox1;
        TMenuItem *ActivateModel1;
        TMenuItem *N1;
        TMenuItem *N2;
        TPopupMenu *PopupMenu3;
        TMenuItem *Resetfailure1;
        TMenuItem *N3;
        TMenuItem *N4;
        TPanel *Panel7;
        TImage *Image4;
        TPanel *Panel9;
        TImage *Image1;
        TPageControl *PageControl4;
        TTabSheet *TabSheet12;
        TTreeList *TreeList1;
        TTabSheet *TabSheet13;
        TAdvStringGrid *AdvStringGrid3;
        TRxGIFAnimator *Animator1;
        TPopupMenu *PopupMenu1;
        TMenuItem *Start1;
        TMenuItem *Stop1;
        TImageList *ImageList2;
        TListView *ListView1;
        TListView *ListView3;
        TPopupMenu *PopupMenu4;
        TMenuItem *MenuItem1;
        TMenuItem *MenuItem2;
        TAdvStringGrid *AdvStringGrid1;
        TImage *Image2;
        TLabel *Label26;
        void __fastcall Button6Click(TObject *Sender);
        void __fastcall CheckBox6Click(TObject *Sender);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall CheckBox2Click(TObject *Sender);
        void __fastcall CheckBox3Click(TObject *Sender);
        void __fastcall CheckBox4Click(TObject *Sender);
        void __fastcall CheckBox5Click(TObject *Sender);
        void __fastcall Edit2Exit(TObject *Sender);
        void __fastcall Edit2Click(TObject *Sender);
        void __fastcall Edit1Click(TObject *Sender);
        void __fastcall Edit2Enter(TObject *Sender);
        void __fastcall EditCode1Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall SuspendModel1Click(TObject *Sender);
        void __fastcall DeleteModel1Click(TObject *Sender);
        void __fastcall MaskEdit2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall EnableAll();
        void __fastcall DisableAll();
        void __fastcall AdvStringGrid1SelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall AdvStringGrid2SelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall AdvStringGrid2CellValidate(TObject *Sender,
          int Col, int Row, AnsiString &Value, bool &Valid);
        void __fastcall AdvStringGrid1CellValidate(TObject *Sender,
          int Col, int Row, AnsiString &Value, bool &Valid);
        void __fastcall ActivateModel1Click(TObject *Sender);
        void __fastcall Resetfailure1Click(TObject *Sender);
        void __fastcall N3Click(TObject *Sender);
        void __fastcall Start1Click(TObject *Sender);
        void __fastcall Stop1Click(TObject *Sender);
        void __fastcall ListView1Click(TObject *Sender);
        void __fastcall ListView3Click(TObject *Sender);
        void __fastcall MenuItem1Click(TObject *Sender);
        void __fastcall MenuItem2Click(TObject *Sender);
private:
        bool __fastcall SetItem(ItemNameEnum itm);
public:
	virtual __fastcall TPagesDlg(TComponent* AOwner);
};
//----------------------------------------------------------------------------
extern PACKAGE TPagesDlg *PagesDlg;
//----------------------------------------------------------------------------
#endif
