//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include <stdlib.h>

#include "RuntimeMonitorMain.h"
#include "RuntimeConsole.h"
#include "ErrorDlg.h"
#include "SocketObj.h"
#include "EngineRequest.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "RxGIF"
#pragma resource "*.dfm"

using namespace std;

TForm1 *Form1;
EngineRequest *er;
bool connected;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StartApp(TObject *Sender)
{
        connected = false;
        Form1->Visible=false;
        Timer1->Enabled=false;
        PagesDlg->MaskEdit2->Text = PagesDlg->ClientSocket1->Address;
        PagesDlg->MaskEdit3->Text = PagesDlg->ClientSocket1->Port;
        if ((PagesDlg->MaskEdit2->Text != "") || (PagesDlg->MaskEdit3->Text != ""))
        {
                PagesDlg->DisableAll();
                PagesDlg->Animator1->Visible = false;
        }
        else
        {
                try {
                        er = new EngineRequest();
                        er->GetEngineStatus();
                        er->LockEngine();
                        er->Refresh();
                        connected = true;
                        PagesDlg->EnableAll();
                } catch (Exception &exception){
                        Application->ShowException(&exception);
                        PagesDlg->DisableAll();
                } catch (exception const &msg) {
                        ErrorDlg1->Label1->Caption = AnsiString("ERR Get Engine State: " +
                                AnsiString(msg.what()));
                        ErrorDlg1->ShowModal();
                        PagesDlg->DisableAll();
                }
        }

        //-------------------------------------------------------------------
        // fire up the console
        PagesDlg->ShowModal();

        //-------------------------------------------------------------------
        // un-lock the engine
        if (connected)
        {
                try {
                        er->UnlockEngine();
                } catch (Exception &exception){
                        Application->ShowException(&exception);
                } catch (exception const &msg) {
                        ErrorDlg1->Label1->Caption = AnsiString("Un-lock Engine " +
                                AnsiString(msg.what()));
                        ErrorDlg1->ShowModal();
                }
        }
        Close();
        exit(0);
}
//---------------------------------------------------------------------------

