//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SocketMsg.h"
#include "ErrorDlg.h"


//---------------------------------------------------------------------------

#pragma package(smart_init)

SocketMsg::SocketMsg(std::string cId, TClientSocket *inCs) : clientId(cId)
{
        s = new SocketObj(cs);
        s->Open();
}

//---------------------------------------------------------------------------
SocketMsg::~SocketMsg()
{
        delete s;
}

//---------------------------------------------------------------------------
bool SocketMsg::SendMsg(std::string msg)
{
        r.clear();
        r["sysClientId"] = clientId;
        r["sysRequest"] = msg;
        r["sysReply"] = "True";
        r["sysDebug"] = "True";

        (*s) << r;
        r.clear();
        (*s) >> r;
        s->Close();

        if (r.find("sysResultStatus") != r.end() &&
            r["sysResultStatus"] == "-1")
        {
                // Processing of message failed in engine
                ErrorDlg1->ShowModal();
                ErrorDlg1->Label1->Caption = AnsiString(r["sysResultString"].c_str());
                return false;
        }
        return true;
}
