//---------------------------------------------------------------------------

#ifndef KnurlyControlH
#define KnurlyControlH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------

#define WM_RESET_COLOR WM_USER+1

enum TArrowDirection {adLeft, adRight, adUp, adDown};
enum TKnurlLayout {klBeforeArrow, klAfterArrow, klBoth};
enum TKnurlOrientation {koHorizontal, koVertical};


class PACKAGE TKnurlyControl : public TCustomControl
{
private:
        bool d_MouseOver;
        bool d_ShowArrow;
        bool d_ArrowDrawn;
        TArrowDirection d_ArrowDirection;
        TKnurlLayout d_KnurlLayout;
        TKnurlOrientation d_KnurlOrientation;
        void __fastcall DrawArrow(int top);
        void __fastcall FShowArrow(bool b);
        void __fastcall FArrowDirection(TArrowDirection ad);
        void __fastcall FKnurlLayout(TKnurlLayout kl);
        void __fastcall FKnurlOrientation(TKnurlOrientation ko);
protected:
        void virtual __fastcall Paint();
        DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
        void __fastcall WMResetColor(TMessage &Message);
        BEGIN_MESSAGE_MAP
           MESSAGE_HANDLER(WM_RESET_COLOR, TMessage, WMResetColor);
        END_MESSAGE_MAP(TCustomControl);

public:
        __fastcall TKnurlyControl(TComponent* Owner);
__published:
        __property bool ShowArrow = {read=d_ShowArrow, write=FShowArrow, default=false};
        __property TArrowDirection ArrowDirection = {read=d_ArrowDirection, write=FArrowDirection, default=adRight};
        __property TKnurlLayout KnurlLayout = {read=d_KnurlLayout, write=FKnurlLayout, default=klBoth};
        __property TKnurlOrientation KnurlOrientation = {read=d_KnurlOrientation, write=FKnurlOrientation, default=koVertical};
        __property Action;
        __property Align;
        __property Anchors;
        __property Cursor;
        __property Enabled;
        __property Left;
        __property Height;
        __property ShowHint;
        __property ParentShowHint;
        __property Tag;
        __property Top;
        __property Width;
        __property Visible;

        __property OnClick;
        __property OnMouseDown;
        __property OnMouseMove;
        __property OnMouseUp;
};
//---------------------------------------------------------------------------
#endif
 