//---------------------------------------------------------------------------

#ifndef OBJBusinessObjectH
#define OBJBusinessObjectH
//---------------------------------------------------------------------------

#include "OBJConnectableObject.h"

class TConnectorObject;

class TBusinessObject : public TConnectableObject
{
   public:
      // CONSTRUCTORS
      __fastcall TBusinessObject();
      __fastcall TBusinessObject(TReader* const);
      static TPersistentEx* createFromStream(TReader* const Reader) {return new TBusinessObject(Reader);}

      // DESTRUCTOR
      __fastcall ~TBusinessObject();

      // ACCESSORS
      TStringList* const __fastcall getObjectCode() const {return d_ObjectCode.get();}
      TBusinessObjectFieldCollection* const getFields() const {return d_Fields.get();}
      TStringList* const __fastcall getObjects() const {return d_Objects.get();}
      TColor __fastcall getGUIColor() const { return (TColor)RGB(175, 215, 255); }

      // MANIPULATORS
      void __fastcall addObjectFields(TConnectorObject* const);

      void __fastcall readData(TReader* const);
      void __fastcall writeData(TWriter* const) const;
      void __fastcall writeXML(TStream* const) const;
      void __fastcall writeScriptCode(TStrings* const) { }
      void __fastcall writeScriptCode(TStrings* const, TStringList* const);

      bool __fastcall showDialog(TComponent* const Owner, bool readOnly);

   private:
      std::auto_ptr<TStringList> d_ObjectCode;
      std::auto_ptr<TBusinessObjectFieldCollection> d_Fields;
      std::auto_ptr<TStringList> d_Objects;
};



#endif
