//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJBusinessObjectField.h"
#include "OBJConnector.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)


//--------------------------------------------------------------------------- TBUSINESSOBJECTFIELD
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - readData(TReader* const)
void __fastcall TBusinessObjectField::readData(TReader* const Reader)
{
   TPersistentEx::readData(Reader);
   d_Mapping = Reader->ReadString();
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeData(TWriter* const)
void __fastcall TBusinessObjectField::writeData(TWriter* const Writer) const
{
   setVersion(0);
   TPersistentEx::writeData(Writer);
   Writer->WriteString(d_Mapping);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeXML(TStream* const) const
void __fastcall TBusinessObjectField::writeXML(TStream* const stream) const
{
   TPersistentEx::writeXML(stream);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeScriptCode(TStringList* const)
void __fastcall TBusinessObjectField::writeScriptCode(TStrings* const code)
{
   String qte = "\"";
   if (d_Mapping.Length()) {
      String conname = d_Mapping.SubString(1, d_Mapping.Pos(".")-1);
      if (ConnectorCollection->findNameI(conname))
         qte = "";
   }
   String codeStr = "          " + d_Name + " = ";
   d_EOROA = codeStr.Length();
   code->AddObject( codeStr + qte + d_Mapping + qte, this);
}

void __fastcall TBusinessObjectField::updateObject(const String& s)
{
   String str = s.Trim();

   str = str.SubString(str.Pos("=")+2, str.Length()).Trim();

   str.Delete(str.Pos("\""), 1);
   str.Delete(str.Pos("\""), 1);
   d_Mapping = str;
}

