//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConditionalObject.h"
#include "OBJConnection.h"
#include "OBJTextObject.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)


//--------------------------------------------------------------------------- TCONDITIONALOBJECT
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - init()
void __fastcall TConditionalObject::init()
{
   d_IfStatement.reset(new TStringList());
   d_TruthStatement.reset(new TStringList());
   d_FalseStatement.reset(new TStringList());
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - constructor ()
__fastcall TConditionalObject::TConditionalObject() : TConnectableObject()
{
   init();
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - constructor (TReader* const)
__fastcall TConditionalObject::TConditionalObject(TReader* const Reader)
: TConnectableObject()
{
   init();
   readData(Reader);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - destructor
__fastcall TConditionalObject::~TConditionalObject()
{
}



//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - readData(TReader* const)
void __fastcall TConditionalObject::readData(TReader* const Reader)
{
   TPersistentEx::readData(Reader);
   Reader->ReadListBegin();
   while (!Reader->EndOfList())
      d_IfStatement->Add(Reader->ReadString());
   Reader->ReadListEnd();

   Reader->ReadListBegin();
   while (!Reader->EndOfList())
      d_TruthStatement->Add(Reader->ReadString());
   Reader->ReadListEnd();

   Reader->ReadListBegin();
   while (!Reader->EndOfList())
      d_FalseStatement->Add(Reader->ReadString());
   Reader->ReadListEnd();

}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeData(TWriter* const) const
void __fastcall TConditionalObject::writeData(TWriter* const Writer) const
{
   setVersion(0);
   TConnectableObject::writeData(Writer);
   Writer->WriteListBegin();
   for (int i=0; i<=d_IfStatement->Count-1; i++)
      Writer->WriteString(d_IfStatement->Strings[i]);
   Writer->WriteListEnd();

   Writer->WriteListBegin();
   for (int i=0; i<=d_TruthStatement->Count-1; i++)
      Writer->WriteString(d_TruthStatement->Strings[i]);
   Writer->WriteListEnd();

   Writer->WriteListBegin();
   for (int i=0; i<=d_FalseStatement->Count-1; i++)
      Writer->WriteString(d_FalseStatement->Strings[i]);
   Writer->WriteListEnd();
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeXML(TStream* const) const
void __fastcall TConditionalObject::writeXML(TStream* Stream) const
{
   TConnectableObject::writeXML(Stream);
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - showDialog(TComponent* const, bool)
bool __fastcall TConditionalObject::showDialog(TComponent* const Owner, bool readOnly)
{
   return false;
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeScriptCode(TStringList* const)
void __fastcall TConditionalObject::writeScriptCode(TStrings* const code)
{

   for (TConnectionCollection::CI cci = d_Connections->begin(); cci != d_Connections->end(); ++cci) {
      TConnectableObject* co = cci->second->getOtherEnd();
      if (co->ClassNameIs("TTextObject"))
         dynamic_cast<TTextObject*>(co)->writeScriptCode(code, 5, true);
   }
   if (d_IfStatement->Count) {
      code->AddObject("     "+d_IfStatement->Text, this);
      code->AddObject("     {", NULL);
      for (int i=0; i<=d_TruthStatement->Count-1; i++)
           code->AddObject("          "+d_TruthStatement->Strings[i], this);
      code->Add("     }");
      if (d_FalseStatement->Count) {
         code->AddObject("     else", NULL);
         code->AddObject("     {", NULL);
         for (int i=0; i<=d_FalseStatement->Count-1; i++)
              code->AddObject("          "+d_FalseStatement->Strings[i], this);
         code->Add("     }");
      }
      code->AddObject("", NULL);
   }
}