//---------------------------------------------------------------------------

#ifndef OBJConditionalObjectH
#define OBJConditionalObjectH
//---------------------------------------------------------------------------

#include "OBJConnectableObject.h"

class TConditionalObject : public TConnectableObject
{
   public:
      // CONSTRUCTORS
      __fastcall TConditionalObject();
      __fastcall TConditionalObject(TReader* const);
      static TPersistentEx* createFromStream(TReader* const Reader) {return new TConditionalObject(Reader);}

      // DESTRUCTOR
      __fastcall ~TConditionalObject();

      // ACCESSORS

      TStringList* const __fastcall getIfStatement() const {return d_IfStatement.get();}
      TStringList* const __fastcall getTruthStatement() const {return d_TruthStatement.get();}
      TStringList* const __fastcall getFalseStatement() const {return d_FalseStatement.get();}
      TColor __fastcall getGUIColor() const {return (TColor)RGB(255, 204, 153);}

      // MANIPULATORS

      void __fastcall readData(TReader* const);
      void __fastcall writeData(TWriter* const) const;
      void __fastcall writeXML(TStream* const) const;
      bool __fastcall showDialog(TComponent* const, bool);
      void __fastcall writeScriptCode(TStrings* const);

   private:
      std::auto_ptr<TStringList> d_IfStatement;
      std::auto_ptr<TStringList> d_TruthStatement;
      std::auto_ptr<TStringList> d_FalseStatement;

      void __fastcall init();
};


#endif
