//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConnection.h"
#include "OBJConnectableObject.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//--------------------------------------------------------------------------- TCONNECTABLEOBJECT
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - init()
void __fastcall TConnectableObject::init()
{
   d_Connections.reset(new TConnectionCollection());
   d_EOROA = 0;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - constructor ()
__fastcall TConnectableObject::TConnectableObject()
: TPersistentEx()
{
   init();
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - constructor (const String&, const String&)
__fastcall TConnectableObject::TConnectableObject(const String& code, const String& name)
: TPersistentEx(code, name)
{
   init();
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - destructor
__fastcall TConnectableObject::~TConnectableObject()
{
   d_Connections->clearObjects();
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - readData(TReader* const)
void __fastcall TConnectableObject::readData(TReader* const Reader)
{
   TPersistentEx::readData(Reader);
   d_GUITop = Reader->ReadInteger();
   d_GUILeft = Reader->ReadInteger();
   d_GUIWidth = Reader->ReadInteger();
   d_GUIHeight = Reader->ReadInteger();
   d_Connections->readData(Reader);
   d_EOROA = Reader->ReadInteger();
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeData(TWriter* const) const
void __fastcall TConnectableObject::writeData(TWriter* const Writer) const
{
   setVersion(0);
   TPersistentEx::writeData(Writer);
   Writer->WriteInteger(d_GUITop);
   Writer->WriteInteger(d_GUILeft);
   Writer->WriteInteger(d_GUIWidth);
   Writer->WriteInteger(d_GUIHeight);
   d_Connections->writeData(Writer);
   Writer->WriteInteger(d_EOROA);
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeXML(TStream* const) const
void __fastcall TConnectableObject::writeXML(TStream* const stream) const
{
   TPersistentEx::writeXML(stream);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeScriptCode(TStrings* const)
void __fastcall TConnectableObject::writeScriptCode(TStrings* const code)
{
}
