//---------------------------------------------------------------------------

#ifndef OBJConnectableObjectH
#define OBJConnectableObjectH
//---------------------------------------------------------------------------

#include "OBJPersistentEx.h"
#include "OBJTypeDefs.h"

class TConnectableObject : public TPersistentEx
{
   public:
      // CREATORS
      __fastcall TConnectableObject();
      __fastcall TConnectableObject(const String&, const String&);
      __fastcall ~TConnectableObject();

      // ACCESSORS
      int __fastcall getGUITop() const {return d_GUITop;}
      int __fastcall getGUILeft() const {return d_GUILeft;}
      int __fastcall getGUIWidth() const {return d_GUIWidth;}
      int __fastcall getGUIHeight() const {return d_GUIHeight;}
      virtual TColor __fastcall getGUIColor() const {return clRed;}
      TConnectionCollection* const __fastcall getConnections() const {return d_Connections.get();}
      int __fastcall getEndOfReadOnlyArea() const {return d_EOROA;}

      // MANIPULATORS
      void __fastcall setGUITop(int i) {d_GUITop = i;}
      void __fastcall setGUILeft(int i) {d_GUILeft = i;}
      void __fastcall setGUIWidth(int i) {d_GUIWidth = i;}
      void __fastcall setGUIHeight(int i) {d_GUIHeight = i;}
      void __fastcall setEndOfReadOnlyArea(int i) {d_EOROA = i;}
      virtual void __fastcall updateObject(const String&) { }
//      virtual void __fastcall setGUIColor(TColor color) { return }

      virtual void __fastcall readData(TReader* const);
      virtual void __fastcall writeData(TWriter* const) const;
      virtual void __fastcall writeXML(TStream* const) const;
      virtual bool __fastcall showDialog(TComponent* const Owner, bool b) {return false;}
      virtual void __fastcall writeScriptCode(TStrings* const);

   protected:
      std::auto_ptr<TConnectionCollection> d_Connections;
      int d_EOROA;

   private:
      int d_GUITop;
      int d_GUILeft;
      int d_GUIWidth;
      int d_GUIHeight;
      void __fastcall init();
};

#endif
