//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConnection.h"

#include "UIConnectionProperties.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//--------------------------------------------------------------------------- TCONNECTION
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - constructor ()
__fastcall TConnection::TConnection()  : TConnectableObject()
{

}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - constructor (TReader* const)
__fastcall TConnection::TConnection(TReader* const Reader)
: TConnectableObject()
{
   readData(Reader);
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - readData(TReader* const)
void __fastcall TConnection::readData(TReader* const Reader)
{
   TConnectableObject::readData(Reader);
   d_Direction = static_cast<TConnectionDirection>(Reader->ReadInteger());
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeData(TWriter* const) const
void __fastcall TConnection::writeData(TWriter* const Writer) const
{
   TConnectableObject::writeData(Writer);
   Writer->WriteInteger(d_Direction);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - writeXML(TStream* const) const
void __fastcall TConnection::writeXML(TStream* const stream) const
{
   TConnectableObject::writeXML(stream);
}


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - showDialog(TComponent* const, bool)
bool __fastcall TConnection::showDialog(TComponent* const Owner, bool ReadOnly)
{
   TfrmConnectionProperties* cp = new TfrmConnectionProperties(Owner, this);
   cp->Show();
   return true;
}
