//---------------------------------------------------------------------------

#ifndef OBJConnectionH
#define OBJConnectionH
//---------------------------------------------------------------------------

#include "OBJConnectableObject.h"


enum TConnectionDirection {cdInbound, cdOutbound, cdBidirectional, cdNone};


class TConnection : public TConnectableObject
{
   public:
      // CREATORS
      __fastcall TConnection();
      __fastcall TConnection(TReader* const);
      static TPersistentEx* createFromStream(TReader* Reader) {return new TConnection(Reader);}

      // ACCESSORS
      TConnectableObject* const __fastcall getSource() const {return d_Source;}
      TConnectableObject* const __fastcall getOtherEnd() const {return d_OtherEnd;}
      TConnectionDirection const __fastcall getDirection() const {return d_Direction;}
      TColor __fastcall getGUIColor() const { return d_GUIColor; }

      // MANIPULATORS
      void __fastcall setSource(TConnectableObject* const co) {d_Source = co;}
      void __fastcall setOtherEnd(TConnectableObject* const co) {d_OtherEnd = co;}
      void __fastcall setDirection(TConnectionDirection const cd) {d_Direction = cd;}
      void __fastcall setGUIColor(const TColor& color) {d_GUIColor = color;}

      virtual void __fastcall readData(TReader* const);
      virtual void __fastcall writeData(TWriter* const) const;
      virtual void __fastcall writeXML(TStream* const) const;
      virtual bool __fastcall showDialog(TComponent* const, bool);

   private:
      TConnectableObject* d_Source;
      TConnectableObject* d_OtherEnd;
      TConnectionDirection d_Direction;
      TColor d_GUIColor;  // Connection objects can have client-definable colors.
};

#endif
