//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConnector.h"
#include "OBJConnectorObject.h"
#include "OBJServletParam.h"

//#include "UIConnectorProperties.h"

//---------------------------------------------------------------------------
#define TConnector_OBJ_VERSION 1

TConnectorCollection* ConnectorCollection = NULL;


void __fastcall TConnector::init()
{
   d_Objects.reset(new TConnectorObjectCollection());
   d_Params.reset(new TServletParamCollection());
}

//---------------------------------------------------------------------------
__fastcall TConnector::TConnector() : TConnectableObject()
{
   init();
}


//---------------------------------------------------------------------------
__fastcall TConnector::TConnector(TReader* const Reader) : TConnectableObject()
{
   init();
   readData(Reader);
}

//---------------------------------------------------------------------------
__fastcall TConnector::TConnector(const String& code, const String& name) : TConnectableObject(code, name)
{
   init();
}


//---------------------------------------------------------------------------
__fastcall TConnector::~TConnector()
{
   d_Objects->clearObjects();
   d_Params->clearObjects();
}


//---------------------------------------------------------------------------
void __fastcall TConnector::readData(TReader* const Reader)
{
   TConnectableObject::readData(Reader);
   d_Objects->readData(Reader);
   d_Params->readData(Reader);
}


//---------------------------------------------------------------------------
void __fastcall TConnector::writeData(TWriter* Writer) const
{
   setVersion(TConnector_OBJ_VERSION);
   TConnectableObject::writeData(Writer);
   d_Objects->writeData(Writer);
   d_Params->writeData(Writer);
}


void __fastcall TConnector::writeXML(TStream* stream) const
{
   setVersion(TConnector_OBJ_VERSION);
   writeXMLStartTag(stream, "TConnector");
   TConnectableObject::writeXML(stream);
   d_Objects->writeXML(stream);
   writeXMLEndTag(stream, "TConnector");
}


//---------------------------------------------------------------------------
bool __fastcall TConnector::showDialog(TComponent* const Owner, bool ReadOnly)
{
   return false;
}



#pragma package(smart_init)
