//---------------------------------------------------------------------------

#ifndef OBJConnectorH
#define OBJConnectorH
//---------------------------------------------------------------------------

#include "OBJConnectableObject.h"

#include "OBJTypeDefs.h"


class TConnector : public TConnectableObject
{
   public:
      // CONSTRUCTORS
      __fastcall TConnector();
      __fastcall TConnector(const String&, const String&);
      __fastcall TConnector(TReader* const);
      static TPersistentEx* createFromStream(TReader* const Reader) {return new TConnector(Reader);}

      // DESTRUCTOR
      __fastcall ~TConnector();

      // ACCESSORS
      TConnectorObjectCollection* const __fastcall getObjects() const {return d_Objects.get();}
      TServletParamCollection* const __fastcall getParams() const {return d_Params.get();}
      TColor __fastcall getGUIColor() const { return (TColor)RGB(236, 236, 120);}

      // MANIPULATORS
      virtual void __fastcall readData(TReader* const);
      virtual void __fastcall writeData(TWriter* const) const;
      virtual void __fastcall writeXML(TStream* const) const;
      virtual bool __fastcall showDialog(TComponent* const, bool);

   private:
      std::auto_ptr<TConnectorObjectCollection> d_Objects;
      std::auto_ptr<TServletParamCollection> d_Params;
      void __fastcall init();

};

extern PACKAGE TConnectorCollection* ConnectorCollection;


#endif
 