//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConnector.h"
#include "OBJConnectableObject.h"
#include "OBJConnectorObjectField.h"
#include "OBJServletMethod.h"
#include "OBJConnectorObject.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

#define TCONNECTOROBJECT_OBJ_VERSION 1

void __fastcall TConnectorObject::init(TConnector* par)
{
   d_Fields.reset(new TConnectorObjectFieldCollection());
   d_Methods.reset(new TServletMethodCollection());
   d_Parent = par;
}


__fastcall TConnectorObject::TConnectorObject(TConnector* par) : TPersistentEx()
{
   init(par);
}

__fastcall TConnectorObject::TConnectorObject(TConnector* const par, const String& code, const String& name) : TPersistentEx(code, name)
{
   init(par);
}

__fastcall TConnectorObject::~TConnectorObject()
{
   d_Fields->clearObjects();
   d_Methods->clearObjects();
}


__fastcall TConnectorObject::TConnectorObject(TReader* const Reader) : TPersistentEx()
{
   readData(Reader);
}





void __fastcall TConnectorObject::readData(TReader* const Reader)
{
   TPersistentEx::readData(Reader);
   d_Fields->readData(Reader);
   d_Methods->readData(Reader);
}


void __fastcall TConnectorObject::writeData(TWriter* const Writer) const
{
   setVersion(0);
   TPersistentEx::writeData(Writer);
   d_Fields->writeData(Writer);
   d_Methods->writeData(Writer);
}

void __fastcall TConnectorObject::writeXML(TStream* stream) const
{
   setVersion(TCONNECTOROBJECT_OBJ_VERSION);
   writeXMLStartTag(stream, "TConnectorObject");
   TPersistentEx::writeXML(stream);
   d_Fields->writeXML(stream);
   d_Methods->writeXML(stream);
   writeXMLEndTag(stream, "TConnectorObject");
}



bool __fastcall TConnectorObject::showDialog(TComponent* const Owner, bool readonly)
{
   return false;
}
