//---------------------------------------------------------------------------

#ifndef OBJConnectorObjectH
#define OBJConnectorObjectH
//---------------------------------------------------------------------------

#include "OBJTypeDefs.h"

class TConnector;

class TConnectorObject : public TPersistentEx
{
   public:
      __fastcall TConnectorObject(TConnector* const);
      __fastcall TConnectorObject(TConnector* const, const String&, const String&);
      __fastcall TConnectorObject(TReader* Reader);

      static TPersistentEx* createFromStream(TReader* const Reader) {return new TConnectorObject(Reader);}

      __fastcall ~TConnectorObject();

      // ACCESSORS
      TConnectorObjectFieldCollection* __fastcall getFields() const {return d_Fields.get();}
      TServletMethodCollection* __fastcall getMethods() const {return d_Methods.get();}

      TConnector* const __fastcall getParent() const {return d_Parent;}

      // MODIFIERS

      virtual void __fastcall readData(TReader* const);
      virtual void __fastcall writeData(TWriter* const) const;
      virtual void __fastcall writeXML(TStream* const) const;
      virtual bool __fastcall showDialog(TComponent* const, bool);

   private:
      std::auto_ptr<TConnectorObjectFieldCollection> d_Fields;
      std::auto_ptr<TServletMethodCollection>  d_Methods;
      TConnector* d_Parent;
      void __fastcall init(TConnector* const);
};



#endif
