//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "OBJReferenceFactory.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
TReferenceFactory* ReferenceFactory;
TReferenceFactory* TReferenceFactory::_instance = 0;
TStringList* TReferenceFactory::d_ReferenceList = 0;


__fastcall TReferenceFactory::TReferenceFactory() : TObject()
{
   if (d_ReferenceList == 0)
      d_ReferenceList = new TStringList();
}

__fastcall TReferenceFactory::~TReferenceFactory()
{
   delete d_ReferenceList;
   _instance = 0;
}

TReferenceFactory* TReferenceFactory::Instance()
{
   if (_instance == 0) {
      _instance= new TReferenceFactory();
   }
   return _instance;
}


String __fastcall TReferenceFactory::makeNewReference(const String& Leader, int count)
{
  const String ValidChars = "23456789ABCDEFGHJKLMNPQRSTUVWXYZ";
  String result;
  int position;
  Word Hours, Minutes, Seconds, Sec100;
  do {
     result = "";
     DecodeTime(Now(), Hours, Minutes, Seconds, Sec100);
     while (!result.Length())
     {
       randomize();
       for (int i=1 ; i <= count; i++)
       {
         RandSeed=random(Hours+Minutes+Seconds+Sec100);
         position=random(ValidChars.Length()+1);
         result+=ValidChars.SubString(position, 1);
       };
       result=Leader+result;
     }
  } while (d_ReferenceList->IndexOf(result) >= 0);
  return result;
}

void __fastcall TReferenceFactory::deleteReference(const String& s)
{
   int pos=d_ReferenceList->IndexOf(s);
   if (pos >= 0)
      d_ReferenceList->Delete(pos);
}

void __fastcall TReferenceFactory::addEntry(const String& s)
{
   if (d_ReferenceList->IndexOf(s) < 0)
      d_ReferenceList->Add(s);
}

