//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJSocket.h"
//#include "DebugWindow.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

SocketObj::SocketObj(TClientSocket *inCs) : //  throw(exception) :
         cs(inCs), ss((TWinSocketStream *) 0)
{
        ss = new TWinSocketStream(cs->Socket, 100);
        ss->TimeOut = 1000;
}
//---------------------------------------------------------------------------

SocketObj::~SocketObj()
{
        if (ss) delete ss;
}
//---------------------------------------------------------------------------
void SocketObj::Close()
{
        cs->Close();
}

//---------------------------------------------------------------------------
void SocketObj::Open()
{
        cs->Open();
}

//---------------------------------------------------------------------------
SocketObj & SocketObj::input(NameValueTyp  &data)// throw(exception)
{
 StringListTyp lData;

        input(lData);
        if (!lData.empty())
        {
                if (lData.size() % 2)
                {
#ifdef WARN
                        cerr << "WARNING: - SocketObj::input(NameValueTyp  &data)"
                             << " list returned with odd size" << endl;
#endif
                }
                else
                {
                        std::string key;
                        for (StringListTyp::iterator it = lData.begin(); it != lData.end(); ++it)
                        {
                                key = *it++;
                                data[key] = *it;
                                Application->ProcessMessages();
                        }
                }
        }
        return *this;
}

//------------------------------------------------------
SocketObj & SocketObj::input(StringListTyp  &strl) //throw(exception)
{
 char c;
 std::string str;
 int n;

        if (ss->WaitForData(10000))    // wait for data for 10 seconds
        for  (;str != EOT;)
        {
                str.erase();
                while (((n = ss->Read(&c, 1)) != -1) && (n != 0) && (c != 0))
                        str += char(c);

                //if ((n == 0) || (n == -1))
                if (!cs->Active)
                {
//                        FormDebugWindow->Memo1->Lines->Append("Breaking out connection is no longe active!");
//                        FormDebugWindow->ShowModal();
                        break;
                }
                if (str != EOT) strl.push_back(str);
                Application->ProcessMessages();
        }

        return *this;
}

//------------------------------------------------------
SocketObj & SocketObj::output(NameValueTyp &data) //throw(exception)
{
 StringListTyp lData;

        for (NameValueTyp::iterator it = data.begin(); it != data.end(); ++it)
        {
                lData.push_back(it->first);
                lData.push_back(it->second);
                Application->ProcessMessages();
        }
        return output(lData);
}

//------------------------------------------------------
SocketObj & SocketObj::output(StringListTyp &data) //throw(exception)
{
 std::string str;

        if (cs->Active)
        {
                for (StringListTyp::iterator it = data.begin(); it != data.end(); ++it)
                        output((char *) (*it).c_str());

                output((char *) EOT);
                Application->ProcessMessages();
        }

        return *this;
}

//------------------------------------------------------
SocketObj & SocketObj::output(char *data) //throw(exception)
{
 int bytesLeft;
 int bytesSent;
 int len, n;

        bytesSent = 0;
        bytesLeft = len = strlen(data) + 1;

//cerr << "--------------------------------Writing out " << data << endl;

        while(cs->Active && bytesSent < len)
        {
//            n = send(sockfd, data + bytesSent, bytesLeft, 0);
            n = ss->Write(data + bytesSent, bytesLeft);
            bytesSent += n;
            bytesLeft -= n;
            Application->ProcessMessages();
        }

        return *this;
}

