//---------------------------------------------------------------------------
#ifndef SocketObjH
#define SocketObjH
//---------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ScktComp.hpp>

#include <list>
#include <map>
#include <vector>
#include <queue>
#include <string>
#include <stdexcept>


//---------------------------------------------------------------------------
#define EOT            "\004"

//---------------------------------------------------------------------------

typedef std::list< std::string > StringListTyp;
typedef std::map< std::string, std::string > NameValueTyp;

//---------------------------------------------------------------------------
class SocketObj //: private fstream
{
 public:
        SocketObj(){}
        SocketObj(TClientSocket *cs); //throw(exception);
        ~SocketObj();

        SocketObj & input(StringListTyp &strl);// throw(exception);
        SocketObj & input(NameValueTyp &data);// throw(exception);

        SocketObj & output(NameValueTyp &data);// throw(exception);
        SocketObj & output(StringListTyp &data);// throw(exception);
        SocketObj & output(char *data);// throw(exception);
        void Open();
        void Close();


         private:

         TWinSocketStream *ss;
         TClientSocket *cs;

};
//----------------------------------------------------------
inline SocketObj & operator >> (SocketObj & s, StringListTyp &data)
{
        return s.input(data);
}

//----------------------------------------------------------
inline SocketObj & operator >> (SocketObj & s, NameValueTyp &data)
{
        return s.input(data);
}

//----------------------------------------------------------
inline SocketObj & operator << (SocketObj & s, NameValueTyp &data)
{
        return s.output(data);
}

//----------------------------------------------------------
inline SocketObj & operator << (SocketObj & s, StringListTyp &data)
{
        return s.output(data);
}

//----------------------------------------------------------
inline SocketObj & operator << (SocketObj & s, char *data)
{
        return s.output(data);
}
#endif
