//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJTextObject.h"

#define TTEXTOBJECT_OBJ_VERSION 1

//---------------------------------------------------------------------------

void __fastcall TTextObject::init()
{
   d_Text.reset(new TStringList());
}

//---------------------------------------------------------------------------
__fastcall TTextObject::TTextObject() : TConnectableObject()
{
   init();
}


//---------------------------------------------------------------------------
__fastcall TTextObject::TTextObject(TReader* const Reader) : TConnectableObject()
{
   init();
   readData(Reader);
}


//---------------------------------------------------------------------------
__fastcall TTextObject::~TTextObject()
{
}


//---------------------------------------------------------------------------
void __fastcall TTextObject::readData(TReader* const Reader)
{
   TConnectableObject::readData(Reader);
   Reader->ReadListBegin();
   while (!Reader->EndOfList())
      d_Text->Add(Reader->ReadString());
   Reader->ReadListEnd();
   d_GUILock = Reader->ReadBoolean();
}


//---------------------------------------------------------------------------
void __fastcall TTextObject::writeData(TWriter* const Writer) const
{
   setVersion(TTEXTOBJECT_OBJ_VERSION);
   TConnectableObject::writeData(Writer);
   Writer->WriteListBegin();
   for (int i=0; i<=d_Text->Count-1; i++)
      Writer->WriteString(d_Text->Strings[i]);
   Writer->WriteListEnd();
   Writer->WriteBoolean(d_GUILock);
}


void __fastcall TTextObject::writeXML(TStream* const stream) const
{
   setVersion(TTEXTOBJECT_OBJ_VERSION);
   writeXMLStartTag(stream, "TTextObject");
   TConnectableObject::writeXML(stream);
   writeXMLEndTag(stream, "TTextObject");
}


//---------------------------------------------------------------------------
bool __fastcall TTextObject::showDialog(TComponent* const Owner, bool ReadOnly)
{
   return false;
}


void __fastcall TTextObject::writeScriptCode(TStrings* const code, int TabLevel, bool supress_whitespace)
{
      for (int i=0; i<=d_Text->Count-1; i++)
         code->AddObject(AnsiString::StringOfChar(' ', TabLevel) + "// " + d_Text->Strings[i], this);
      if (!supress_whitespace)
         code->Add("");
}

#pragma package(smart_init)
