//---------------------------------------------------------------------------

#ifndef OBJTextObjectH
#define OBJTextObjectH
//---------------------------------------------------------------------------

#include "OBJConnectableObject.h"

class TTextObject : public TConnectableObject
{
   public:
      // CONSTRUCTORS
      __fastcall TTextObject();
      __fastcall TTextObject(TReader* const);
      static TPersistentEx* createFromStream(TReader* const Reader) {return new TTextObject(Reader);}

      // DESTRUCTOR
      __fastcall ~TTextObject();

      // ACCESSORS
      TStringList* const __fastcall getText() const {return d_Text.get();}
      bool __fastcall getGUILock() const {return d_GUILock;}
      TColor __fastcall getGUIColor() const { return (TColor)RGB(160,220,140); }

      // MANIPULATORS
      void __fastcall setGUILock(bool b) {d_GUILock = b;}

      void __fastcall readData(TReader* const);
      void __fastcall writeData(TWriter* const) const;
      void __fastcall writeXML(TStream* const) const;
      bool __fastcall showDialog(TComponent* const, bool);
      void __fastcall writeScriptCode(TStrings* const) { }
      void __fastcall writeScriptCode(TStrings* const, int TabLevel, bool supress_whitespace=false);

   private:
      bool d_GUILock;
      std::auto_ptr<TStringList> d_Text;
      void __fastcall init();
};


#endif
