//---------------------------------------------------------------------------

#ifndef OBJTransactionH
#define OBJTransactionH
//---------------------------------------------------------------------------

#include "OBJTypeDefs.h"
#include "OBJConnectableObject.h"

class TTransaction : public TConnectableObject
{
   public:
      // CONSTRUCTORS
      __fastcall TTransaction();
      __fastcall TTransaction(TReader* const);
      static TPersistentEx* createFromStream(TReader* const Reader) {return new TTransaction(Reader);}

      // DESTRUCTOR
      __fastcall ~TTransaction();

      // ACCESSORS
      TBusinessObjectCollection* const __fastcall getBusinessObjects() const {return d_BusinessObjects.get();}
      TConnectorCollection* const __fastcall getConnectors() const {return d_Connectors.get();}
      TTextObjectCollection* const __fastcall getTextObjects() const {return d_TextObjects.get();}
      TConditionalObjectCollection* const __fastcall getConditionalObjects() const {return d_ConditionalObjects.get();}
      TTransformerCollection* const __fastcall getTransformers() const {return d_Transformers.get();}


      // MANIPULATORS
      virtual void __fastcall readData(TReader* const);
      virtual void __fastcall writeData(TWriter* const) const;
      virtual void __fastcall writeXML(TStream* const) const;
      virtual bool __fastcall showDialog(TComponent* const, bool);
      void __fastcall writeScriptCode(TStrings* const);
      void __fastcall updateObject(const String&);

   private:
      std::auto_ptr<TBusinessObjectCollection> d_BusinessObjects;
      std::auto_ptr<TConnectorCollection> d_Connectors;
      std::auto_ptr<TTextObjectCollection> d_TextObjects;
      std::auto_ptr<TConditionalObjectCollection> d_ConditionalObjects;
      std::auto_ptr<TTransformerCollection> d_Transformers;

      void __fastcall init();
};


#endif
