//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJServletParam.h"
#include "OBJServletMethod.h"
#include "OBJTransformer.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

TTransformerCollection* TransformerCollection = NULL;

void __fastcall TTransformer::init()
{
   d_Params.reset(new TServletParamCollection());
   d_Methods.reset(new TServletMethodCollection());
}


__fastcall TTransformer::TTransformer()
           : TConnectableObject()
{
   init();
}


__fastcall TTransformer::TTransformer(TReader* const Reader)
           : TConnectableObject()
{
   init();
   readData(Reader);
}

__fastcall TTransformer::TTransformer(const String& c, const String& n)
           :TConnectableObject(c, n)
{
   init();
}

__fastcall TTransformer::~TTransformer()
{

}

void __fastcall TTransformer::readData(TReader* const Reader)
{
   TConnectableObject::readData(Reader);
   d_Params->readData(Reader);
   d_Methods->readData(Reader);
}


void __fastcall TTransformer::writeData(TWriter* const Writer) const
{
   setVersion(0);
   TConnectableObject::writeData(Writer);
   d_Params->writeData(Writer);
   d_Methods->writeData(Writer);
}

void __fastcall TTransformer::writeXML(TStream* const stream) const
{

}


bool __fastcall TTransformer::showDialog(TComponent* const Owner, bool ReadOnly)
{
   return false;
}

void __fastcall TTransformer::writeScriptCode(TStrings* const code)
{

}