//---------------------------------------------------------------------------

#ifndef OBJTransformerH
#define OBJTransformerH
//---------------------------------------------------------------------------
#include "OBJConnectableObject.h"

class TTransformer : public TConnectableObject
{
   public:
      // CONSTRUCTORS
      __fastcall TTransformer();
      __fastcall TTransformer(TReader* const);
      __fastcall TTransformer(const String&, const String&);
      static TPersistentEx* createFromStream(TReader* const Reader) {return new TTransformer(Reader);}

      // DESTRUCTOR
      __fastcall ~TTransformer();

      // ACCESSORS
      const std::auto_ptr<TServletParamCollection>& getParams() const { return d_Params; }
      const std::auto_ptr<TServletMethodCollection>& getMethods() const { return d_Methods; }
      TColor __fastcall getGUIColor() const {return (TColor)RGB(255, 176, 86); }
      
      // MANIPULATORS

      virtual void __fastcall readData(TReader* const);
      virtual void __fastcall writeData(TWriter* const) const;
      virtual void __fastcall writeXML(TStream* const) const;
      virtual bool __fastcall showDialog(TComponent* const, bool);
      virtual void __fastcall writeScriptCode(TStrings* const);

   private:
      std::auto_ptr<TServletParamCollection> d_Params;
      std::auto_ptr<TServletMethodCollection> d_Methods;
      void __fastcall init();

};

extern PACKAGE TTransformerCollection* TransformerCollection;


#endif
