//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SYSObjectMapping.h"

#include "OBJBusinessObject.h"
#include "OBJBusinessObjectField.h"
#include "OBJConditionalObject.h"
#include "OBJConnection.h"
#include "OBJConnector.h"
#include "OBJConnectorObject.h"
#include "OBJConnectorObjectField.h"
#include "OBJServletMethod.h"
#include "OBJServletParam.h"
#include "OBJTextObject.h"
#include "OBJTransaction.h"
#include "OBJTransformer.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

#define CLASSMAP(name) SystemObjectMap[#name]=&name::createFromStream

std::map<String, PF> SystemObjectMap;

void __fastcall initObjectMap()
{
   CLASSMAP(TBusinessObject);
   CLASSMAP(TBusinessObjectField);
   CLASSMAP(TConditionalObject);
   CLASSMAP(TConnection);
   CLASSMAP(TConnector);
   CLASSMAP(TConnectorObject);
   CLASSMAP(TConnectorObjectField);
   CLASSMAP(TServletMethod);
   CLASSMAP(TServletParam);
   CLASSMAP(TTextObject);
   CLASSMAP(TTransaction);
   CLASSMAP(TTransformer);
}

TPersistentEx* __fastcall getObject(TReader* Reader)
{
   String classname = Reader->ReadString();
   PF createfunc = SystemObjectMap[classname];
   if (!createfunc)
      return NULL;

   return createfunc(Reader);
}




