//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJBusinessObject.h"
#include "OBJConnection.h"
#include "OBJSystemMessages.h"

#include "UIBusinessObjectProperties.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "dccommon"
#pragma link "dcmemo"
#pragma link "dcparser"
#pragma link "dcstring"
#pragma link "dcsystem"
#pragma resource "*.dfm"
TfrmBusinessObjectProperties *frmBusinessObjectProperties;
//---------------------------------------------------------------------------
__fastcall TfrmBusinessObjectProperties::TfrmBusinessObjectProperties(TComponent* Owner, TBusinessObject* bo)
        : TForm(Owner)
{
   d_BusinessObject = bo;
   Caption = "Business Object - " + bo->getName(); 
   ebName->Text = bo->getName();
   MemoSource1->Lines->AddStrings(bo->getObjectCode());
   PageControl1->ActivePage = TabSheet1;
   for (TConnectionCollection::CI cci = bo->getConnections()->begin(); cci != bo->getConnections()->end(); ++cci) {
      TListItem* Item = lvConnections->Items->Add();
      Item->Caption = cci->second->getOtherEnd()->getName();
      String typeString;
      Item->SubItems->Add(String(cci->second->getOtherEnd()->ClassName()).SubString(2, 25));
      String directionString;
      switch(cci->second->getDirection()) {
         case cdInbound:
            directionString = "Inbound";
            break;
         case cdOutbound:
            directionString = "Outbound";
            break;
         case cdBidirectional:
            directionString = "Bidirectional";
            break;
         case cdNone:
            directionString = "(n/a)";
      }
      Item->SubItems->Add(directionString);
   }
}
//---------------------------------------------------------------------------
void __fastcall TfrmBusinessObjectProperties::ebNameKeyPress(
      TObject *Sender, char &Key)
{
   String validChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_\b";
   if (!validChars.Pos(String(Key).UpperCase()))
      Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfrmBusinessObjectProperties::ebNameChange(TObject *Sender)
{
   Caption = "Business Object - " + ebName->Text;
   btnOK->Enabled = ebName->Text.Length();
}
//---------------------------------------------------------------------------
void __fastcall TfrmBusinessObjectProperties::btnOKClick(TObject *Sender)
{
   d_BusinessObject->setName(ebName->Text);
   d_BusinessObject->getObjectCode()->Clear();
   d_BusinessObject->getObjectCode()->AddStrings(MemoSource1->Lines);
   PostMessage(dynamic_cast<TForm*>(Owner)->Handle, smObjectPropertiesChanged, 1, (long)d_BusinessObject);
   Close();
}


//---------------------------------------------------------------------------
void __fastcall TfrmBusinessObjectProperties::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TfrmBusinessObjectProperties::btnCancelClick(
      TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------

