//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "dcmemopt.hpp"
#include "dcenvopt.hpp"

#include "OBJConnectableObject.h"
#include "OBJTransaction.h"
#include "OBJSocket.h"
#include "OBJSystemMessages.h"

#include "UIAnimateLoad.h"
#include "UICommandScriptViewer.h"
#include "UIMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "dccommon"
#pragma link "dcmemo"
#pragma link "dcstring"
#pragma link "dcSyntax"
#pragma link "dcsystem"
#pragma link "Placemnt"
#pragma link "SpeedBar"
#pragma resource "*.dfm"
TfrmCommandScriptViewer* frmCommandScriptViewer = NULL;
TfrmCommandScriptViewer* TfrmCommandScriptViewer::_instance = 0;
//---------------------------------------------------------------------------
__fastcall TfrmCommandScriptViewer::TfrmCommandScriptViewer(TComponent* Owner, TTransaction* tran)
        : TForm(Owner)
{
   d_tran = tran;
   frmMain->aScriptEnvironmentOptions->Visible = true;
}


TfrmCommandScriptViewer* TfrmCommandScriptViewer::Instance(TComponent* Owner, TTransaction* tran)
{
   if (_instance == 0) {
      _instance= new TfrmCommandScriptViewer(Owner, tran);
   }
   return _instance;
}

__fastcall TfrmCommandScriptViewer::~TfrmCommandScriptViewer()
{
   _instance = 0;
   frmCommandScriptViewer = 0;
   frmMain->aScriptEnvironmentOptions->Visible = false;
}


//---------------------------------------------------------------------------
void __fastcall TfrmCommandScriptViewer::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Action = caFree;
   _instance = 0;
   frmCommandScriptViewer = 0;
   SendMessage(dynamic_cast<TForm*>(Owner)->Handle, smCommandScriptViewerClosed, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TfrmCommandScriptViewer::btnSendToHostClick(TObject *Sender)
{

   frmAnimateLoad = new TfrmAnimateLoad(this);
   frmAnimateLoad->Label1->Caption = "Registering Business Process...";
   frmAnimateLoad->Show();
   Application->ProcessMessages();
   NameValueTyp r;

   r["sysRequest"]="Register Transaction";
   r["sysClientId"]="BusinessProcessModeller";
   r["sysFileName"]=d_tran->getName().c_str();
   r["sysData"]=MemoSource1->Lines->Text.c_str();
   r["sysInstall"]="True";

   SocketObj s(frmMain->ClientSocket1);
   try {
      s.Open();
      s << r;
      r.clear();
      s >> r;
      s.Close();
      delete frmAnimateLoad;
      Application->MessageBox("The Business Process Model has been registered with the server.", "Registration Successful", MB_OK);
   }
   catch (...)  {
      delete frmAnimateLoad;
      Application->MessageBox("An error occured when trying to register the Business Process Model.", "Registration Failed", MB_OK);
   }
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::DCMemo1ClickGutter(
      TObject *Sender, int LinePos, int ImageIndex, TShiftState Shift)
{
   if (ImageIndex < 0)
       DCMemo1->MemoSource->ImageBit[LinePos][0] = true;
   else
       DCMemo1->MemoSource->ImageBit[LinePos][0] = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::FormEndDock(TObject *Sender,
      TObject *Target, int X, int Y)
{
    StatusBar1->Visible = !Target;
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::ToolButton2Click(TObject *Sender)
{
   ShowEnvironmentOptions();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::Undo1Click(TObject *Sender)
{
   DCMemo1->MemoSource->Undo();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::DCMemo1Change(TObject *Sender)
{
//   Undo1->Enabled = DCMemo1->MemoSource->UndoAvailable();  // prob not necessary, because of the state-change handler
   if (!Visible)
      return;
   TCustomMemoSource* ms = DCMemo1->MemoSource;
   if (ms->Lines->Objects[ms->CurLinePos]) {
      dynamic_cast<TConnectableObject*>(ms->Lines->Objects[ms->CurLinePos])->updateObject(ms->Lines->Strings[ms->CurLinePos].Trim());
      SendMessage(dynamic_cast<TForm*>(Owner)->Handle, smUpdateInspector, 0, (long)ms->Lines->Objects[ms->CurLinePos]);
      if (ms->Lines->Objects[ms->CurLinePos]->ClassNameIs("TBusinessObjectField"))
         SendMessage(dynamic_cast<TForm*>(Owner)->Handle, smUpdateBOConnections, 0, 0);
      if (ms->Lines->Objects[ms->CurLinePos]->ClassNameIs("TTransaction"))
         SendMessage(dynamic_cast<TForm*>(Owner)->Handle, smTransactionNameChanged, 0, 0);
   }
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::Redo1Click(TObject *Sender)
{
   DCMemo1->MemoSource->Redo();        
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::Cut1Click(TObject *Sender)
{
   DCMemo1->MemoSource->CutBlock();
   Paste1->Enabled = DCMemo1->MemoSource->CanPaste();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::Copy1Click(TObject *Sender)
{
   DCMemo1->MemoSource->CopyBlock();
   Paste1->Enabled = DCMemo1->MemoSource->CanPaste();
}
//---------------------------------------------------------------------------


void __fastcall TfrmCommandScriptViewer::Paste1Click(TObject *Sender)
{
   DCMemo1->MemoSource->PasteBlock();
}
//---------------------------------------------------------------------------


void __fastcall TfrmCommandScriptViewer::Delete1Click(TObject *Sender)
{
   DCMemo1->MemoSource->DeleteBlock();
   Paste1->Enabled = DCMemo1->MemoSource->CanPaste();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::SelectAll1Click(TObject *Sender)
{
   DCMemo1->MemoSource->SelectAll();
   Paste1->Enabled = DCMemo1->MemoSource->CanPaste();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::GotoLineNumber1Click(
      TObject *Sender)
{
   DCMemo1->MemoSource->ShowGoToLineDialog();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::Find1Click(TObject *Sender)
{
   DCMemo1->MemoSource->ShowSearchDialog();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::Replace1Click(TObject *Sender)
{
   DCMemo1->MemoSource->ShowReplaceDialog();        
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::SearchAgain1Click(TObject *Sender)
{
   DCMemo1->MemoSource->FindNext();        
}
//---------------------------------------------------------------------------

void __fastcall TfrmCommandScriptViewer::Close1Click(TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------



void __fastcall TfrmCommandScriptViewer::DCMemo1StateChange(
      TObject *Sender, TMemoStates State)
{
   TCustomMemoSource* ms = DCMemo1->MemoSource;
//   if (State.Contains(msPositionChanged) && d_ChangePending) {
//      d_ChangeObject->updateObject(d_ChangeString);
//      SendMessage(dynamic_cast<TForm*>(Owner)->Handle, smUpdateInspector, 0, (long)d_ChangeObject);
//      d_ChangePending = false;
//      d_ChangeObject = NULL;
//      d_ChangeString = "";
//   }

   int xPos = ms->CurCharPos;
   int yPos = ms->CurLinePos;

   if (ms->Lines->Objects[yPos]) {
      ms->ReadOnly = xPos < dynamic_cast<TConnectableObject*>(ms->Lines->Objects[yPos])->getEndOfReadOnlyArea();
   }
   else {
      ms->ReadOnly = false;
   }

   if (State.Contains(msReadOnlyChanged)) {
      SendMessage(dynamic_cast<TForm*>(Owner)->Handle, smUpdateStatusBarRO, ms->ReadOnly ? 1 : 0, 0);
      if (ms->ReadOnly)
         StatusBar1->SimpleText = "Read-Only Area";
      else
         StatusBar1->SimpleText = "";
   }


   Paste1->Enabled = !ms->ReadOnly && ms->CanPaste();
   Undo1->Enabled = ms->UndoAvailable();
   Redo1->Enabled = ms->RedoAvailable();
}
//---------------------------------------------------------------------------

