//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConditionalObject.h"
#include "OBJConnection.h"
#include "OBJSystemMessages.h"

#include "UIConditionalObjectProperties.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "dccommon"
#pragma link "dcmemo"
#pragma link "htmlbtns"
#pragma resource "*.dfm"
TfrmConditionalObjectProperties *frmConditionalObjectProperties;
//---------------------------------------------------------------------------
__fastcall TfrmConditionalObjectProperties::TfrmConditionalObjectProperties(TComponent* Owner, TConditionalObject* co)
        : TForm(Owner)
{
   d_ConditionalObject = co;
   Caption = "Conditional Object - " + co->getName();
   ebName->Text = co->getName();
//   MemoSource1->Lines->AddStrings(co->getObjectCode());
   PageControl1->ActivePage = TabSheet1;
   for (TConnectionCollection::CI cci = co->getConnections()->begin(); cci != co->getConnections()->end(); ++cci) {
      TListItem* Item = lvConnections->Items->Add();
      Item->Caption = cci->second->getOtherEnd()->getName();
      String typeString;
      Item->SubItems->Add(String(cci->second->getOtherEnd()->ClassName()).SubString(2, 25));
      String directionString;
      switch(cci->second->getDirection()) {
         case cdInbound:
            directionString = "Inbound";
            break;
         case cdOutbound:
            directionString = "Outbound";
            break;
         case cdBidirectional:
            directionString = "Bidirectional";
            break;
         case cdNone:
            directionString = "(n/a)";
      }
      Item->SubItems->Add(directionString);
   }
}



//---------------------------------------------------------------------------
void __fastcall TfrmConditionalObjectProperties::rbtnStatementTypeClick(
      TObject *Sender)
{
   Notebook1->PageIndex = dynamic_cast<THTMLRadioButton*>(Sender)->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TfrmConditionalObjectProperties::ebNameKeyPress(
      TObject *Sender, char &Key)
{
   String validChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_\b";
   if (!validChars.Pos(String(Key).UpperCase()))
      Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfrmConditionalObjectProperties::ebNameChange(
      TObject *Sender)
{
   Caption = "Conditional Object - " + ebName->Text;
   btnOK->Enabled = ebName->Text.Length();        
}


//---------------------------------------------------------------------------
void __fastcall TfrmConditionalObjectProperties::btnOKClick(
      TObject *Sender)
{
   d_ConditionalObject->setName(ebName->Text);
   d_ConditionalObject->setIfStatement(memIfStatement->Lines->Text);
   
   PostMessage(dynamic_cast<TForm*>(Owner)->Handle, smObjectPropertiesChanged, 1, (long)d_ConditionalObject);
   Close();
}
//---------------------------------------------------------------------------


void __fastcall TfrmConditionalObjectProperties::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TfrmConditionalObjectProperties::btnCancelClick(
      TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------

