//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConnection.h"
#include "OBJConnectableObject.h"
#include "OBJTypeDefs.h"

#include "UIConnectionManager.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmConnectionManager *frmConnectionManager;
//---------------------------------------------------------------------------
__fastcall TfrmConnectionManager::TfrmConnectionManager(TComponent* Owner, TConnectableObject* co)
        : TForm(Owner)
{
   Caption = "Connections - " + co->getName();
   for (TConnectionCollection::CI cci = co->getConnections()->begin(); cci != co->getConnections()->end(); ++cci) {
      TListItem* Item = lvConnections->Items->Add();
      Item->Caption = cci->second->getOtherEnd()->getName();
      String typeString;
      Item->SubItems->Add(String(cci->second->getOtherEnd()->ClassName()).SubString(2, 25));
      String directionString;
      switch(cci->second->getDirection()) {
         case cdInbound:
            directionString = "Inbound";
            break;
         case cdOutbound:
            directionString = "Outbound";
            break;
         case cdBidirectional:
            directionString = "Bidirectional";
      }
      Item->SubItems->Add(directionString);
   }
}
//---------------------------------------------------------------------------

void __fastcall TfrmConnectionManager::Button1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectionManager::Button2Click(TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectionManager::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
