//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConnection.h"
#include "OBJConnectorObject.h"
#include "OBJSystemMessages.h"

#include "UIConnectorObjectProperties.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "htmcombo"
#pragma link "SKEdit"
#pragma resource "*.dfm"
TfrmConnectorObjectProperties *frmConnectorObjectProperties;

//---------------------------------------------------------------------------
__fastcall TfrmConnectorObjectProperties::TfrmConnectorObjectProperties(TComponent* Owner, TConnectorObject* co)
        : TForm(Owner)
{
   d_ConnectorObject = co;
   Caption = "Connector Object - " + co->getName();
   ebName->Text = co->getName();
   PageControl1->ActivePage = TabSheet1;
   for (TConnectionCollection::CI cci = co->getConnections()->begin(); cci != co->getConnections()->end(); ++cci) {
      TListItem* Item = lvConnections->Items->Add();
      Item->Caption = cci->second->getOtherEnd()->getName();
      String typeString;
      Item->SubItems->Add(String(cci->second->getOtherEnd()->ClassName()).SubString(2, 25));
      String directionString;
      switch(cci->second->getDirection()) {
         case cdInbound:
            directionString = "Inbound";
            break;
         case cdOutbound:
            directionString = "Outbound";
            break;
         case cdBidirectional:
            directionString = "Bidirectional";
      }
      Item->SubItems->Add(directionString);
   }

}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectorObjectProperties::ebNameKeyPress(
      TObject *Sender, char &Key)
{
   String validChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_\b";
   if (!validChars.Pos(String(Key).UpperCase()))
      Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectorObjectProperties::ebNameChange(
      TObject *Sender)
{
   Caption = "Connector Object - " + ebName->Text;
   btnOK->Enabled = ebName->Text.Length();
}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectorObjectProperties::btnOKClick(TObject *Sender)
{
   d_ConnectorObject->setName(ebName->Text);
   PostMessage(dynamic_cast<TForm*>(Owner)->Handle, smObjectPropertiesChanged, 1, (long)d_ConnectorObject);
   Close();
}
//---------------------------------------------------------------------------


void __fastcall TfrmConnectorObjectProperties::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TfrmConnectorObjectProperties::btnCancelClick(
      TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------

