//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJConnector.h"
#include "OBJConnectorObject.h"
#include "OBJConnectorObjectDragObject.h"

#include "UIConnectorObjects.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "htmltv"
#pragma resource "*.dfm"
TfrmConnectorObjects *frmConnectorObjects;
//---------------------------------------------------------------------------
__fastcall TfrmConnectorObjects::TfrmConnectorObjects(TComponent* Owner, TConnectableObject* co)
        : TForm(Owner)
{
   d_co = dynamic_cast<TConnector*>(co);
   HTMLTreeview1->Items->Clear();
   for (TConnectorObjectCollection::CI coc = d_co->getObjects()->begin(); coc != d_co->getObjects()->end(); ++coc) {
      TTreeNode* objNode = HTMLTreeview1->Items->Add(NULL, "<B>"+coc->first);
      for (TConnectorObjectFieldCollection::CI cofi = coc->second->getFields()->begin(); cofi != coc->second->getFields()->end(); ++cofi) {
         TTreeNode* fldNode = HTMLTreeview1->Items->AddChild(objNode, "<IMG src=\"idx:0\">"+cofi->first);
         fldNode->ImageIndex = 0;
      }
      for (TServletMethodCollection::CI comi = coc->second->getMethods()->begin(); comi != coc->second->getMethods()->end(); ++comi) {
         TTreeNode* mthNode = HTMLTreeview1->Items->AddChild(objNode, "<IMG src=\"idx:3\">"+comi->first);
         mthNode->ImageIndex = 3;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectorObjects::btnCloseClick(TObject *Sender)
{
   Close();       
}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectorObjects::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Action = caFree;        
}
//---------------------------------------------------------------------------
void __fastcall TfrmConnectorObjects::HTMLTreeview1StartDrag(
      TObject *Sender, TDragObject *&DragObject)
{
   if (HTMLTreeview1->Selected->HasChildren) {
      TConnectorObjectDragObject* codo = new TConnectorObjectDragObject();
      codo->ConnectorObject = new TConnectorObject(d_co, HTMLTreeview1->Selected->Text.SubString(4, 255), HTMLTreeview1->Selected->Text.SubString(4, 255));
      DragObject = codo;
   }
   else {

   }
}
//---------------------------------------------------------------------------

