//---------------------------------------------------------------------------

#ifndef UIObjectInspectorH
#define UIObjectInspectorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Db.hpp>
#include <IBCustomDataSet.hpp>
#include <IBDatabase.hpp>
#include <IBTable.hpp>
#include "rmInspector.hpp"
#include "RegularExpression.h"
#include "RegularExpressionCustom.h"
#include "ToolEdit.hpp"
#include <Mask.hpp>
//---------------------------------------------------------------------------

#include "OBJSystemMessages.h"
#include <ImgList.hpp>

class TConnectableObject;


struct TNAMEINFO {
   TConnectableObject* obj;
   String name;
};


class TfrmObjectInspector : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TrmInspector *rmInspector1;
        TrmInspector *rmInspector2;
        RegularExpression *RegularExpression1;
        TImageList *ImageList1;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall rmInspector1ComplexEdit(TObject *Sender);
        void __fastcall rmInspector1EditorKeyPress(TObject *Sender,
          char &Key);
        void __fastcall rmInspector1EditorCreated(TObject *Sender);
        void __fastcall rmInspector1EditorKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall rmInspector1StartDrag(TObject *Sender,
          TDragObject *&DragObject);
        void __fastcall rmInspector1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall rmInspector1DragDrop(TObject *Sender,
          TObject *Source, int X, int Y);
        void __fastcall rmInspector1DragOver(TObject *Sender,
          TObject *Source, int X, int Y, TDragState State, bool &Accept);
        void __fastcall rmInspector1EditorExit(TObject *Sender);
        void __fastcall rmInspector1ItemIndexChanging(
          TrmTreeNonViewNode *CurrentNode, TrmTreeNonViewNode *NewNode,
          bool &AllowChange);
private:	// User declarations
        TConnectableObject* d_co;
        String __fastcall GetFieldNameFromPath(const String& path);
        void __fastcall rmInspector1ComboChanged(TObject* Sender);
        String d_EditorString;
        bool d_ProcessingDrag;
        void __fastcall SMRefreshInspectorHandler(TMessage& msg);
        void __fastcall SMUpdateContentsHandler(TMessage& msg);
        BEGIN_MESSAGE_MAP
           MESSAGE_HANDLER(smRefreshInspector, TMessage, SMRefreshInspectorHandler);
           MESSAGE_HANDLER(smUpdateContents, TMessage, SMUpdateContentsHandler);
        END_MESSAGE_MAP(TForm);
public:		// User declarations
        __fastcall TfrmObjectInspector(TComponent* Owner, TConnectableObject* co);
        void __fastcall rebuild(TConnectableObject* co);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmObjectInspector *frmObjectInspector;
//---------------------------------------------------------------------------
#endif
