//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJBusinessObjectFieldDragObject.h"
#include "OBJConditionalObject.h"
#include "OBJConnectableObject.h"
#include "OBJConnector.h"
#include "OBJConnectorObject.h";
#include "OBJConnectorObjectField.h"
#include "OBJConnectorObjectFieldDragObject.h"
#include "OBJServletMethod.h"
#include "OBJServletMethodDragObject.h"
#include "OBJSystemMessages.h"

#include "UIStatementEditor.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "dccommon"
#pragma link "dcmemo"
#pragma link "htmlbtns"
#pragma link "dcstring"
#pragma link "dcSyntax"
#pragma link "dcsystem"
#pragma resource "*.dfm"
TfrmStatementEditor *frmStatementEditor;


//---------------------------------------------------------------------------
__fastcall TfrmStatementEditor::TfrmStatementEditor(TComponent* Owner, TConditionalObject* co)
        : TForm(Owner)
{
   d_co = co;
   MemoSource1->Lines->AddStrings(dynamic_cast<TConditionalObject*>(co)->getIfStatement());
   MemoSource2->Lines->AddStrings(dynamic_cast<TConditionalObject*>(co)->getTruthStatement());
   MemoSource3->Lines->AddStrings(dynamic_cast<TConditionalObject*>(co)->getFalseStatement());
   d_SaveIf = new TStringList();
   d_SaveTrue = new TStringList();
   d_SaveFalse = new TStringList();
   d_SaveIf->AddStrings(MemoSource1->Lines);
   d_SaveTrue->AddStrings(MemoSource1->Lines);
   d_SaveFalse->AddStrings(MemoSource1->Lines);
}


//---------------------------------------------------------------------------
__fastcall TfrmStatementEditor::~TfrmStatementEditor()
{
   delete d_SaveIf;
   delete d_SaveTrue;
   delete d_SaveFalse;
}

//---------------------------------------------------------------------------
void __fastcall TfrmStatementEditor::rbtnStatementTypeClick(
      TObject *Sender)
{
   Notebook1->PageIndex = dynamic_cast<THTMLRadioButton*>(Sender)->Tag;
}


//---------------------------------------------------------------------------
void __fastcall TfrmStatementEditor::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Action = caFree;
}


//---------------------------------------------------------------------------
void __fastcall TfrmStatementEditor::btnOKClick(TObject *Sender)
{
   d_co->getIfStatement()->Clear();
   d_co->getIfStatement()->AddStrings(MemoSource1->Lines);
   d_co->getTruthStatement()->Clear();
   d_co->getTruthStatement()->AddStrings(MemoSource2->Lines);
   d_co->getFalseStatement()->Clear();
   d_co->getFalseStatement()->AddStrings(MemoSource3->Lines);

   PostMessage(dynamic_cast<TForm*>(Owner)->Handle, smObjectPropertiesChanged, 1, (long)d_co);
   Close();
}


//---------------------------------------------------------------------------
void __fastcall TfrmStatementEditor::Button3Click(TObject *Sender)
{
   d_co->getIfStatement()->Clear();
   d_co->getIfStatement()->AddStrings(d_SaveIf);
   d_co->getTruthStatement()->Clear();
   d_co->getTruthStatement()->AddStrings(d_SaveTrue);
   d_co->getFalseStatement()->Clear();
   d_co->getFalseStatement()->AddStrings(d_SaveFalse);
   PostMessage(dynamic_cast<TForm*>(Owner)->Handle, smObjectPropertiesChanged, 1, (long)d_co);
   Close();
}


//---------------------------------------------------------------------------

void __fastcall TfrmStatementEditor::memStatementKeyUp(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
   if (Sender == memIfStatement) {
      d_co->getIfStatement()->Clear();
      d_co->getIfStatement()->AddStrings(MemoSource1->Lines);
   }
   if (Sender == memTrueStatement) {
      d_co->getTruthStatement()->Clear();
      d_co->getTruthStatement()->AddStrings(MemoSource2->Lines);
   }
   if (Sender == memFalseStatement) {
      d_co->getFalseStatement()->Clear();
      d_co->getFalseStatement()->AddStrings(MemoSource3->Lines);
   }
   PostMessage(dynamic_cast<TForm*>(Owner)->Handle, smObjectPropertiesChanged, 1, (long)d_co);
}
//---------------------------------------------------------------------------


void __fastcall TfrmStatementEditor::memTrueStatementDragDrop(
      TObject *Sender, TObject *Source, int X, int Y)
{
   if (Source->ClassNameIs("TServletMethodDragObject")) {
      TServletMethodDragObject* comdo = dynamic_cast<TServletMethodDragObject*>(Source);
      String mapstring = comdo->Connector->getName()+"."+comdo->ConnectorObject->getName()+"."+comdo->ServletMethod->getName();
      dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Add("run_method " + mapstring);
//      delete comdo;
   }
}
//---------------------------------------------------------------------------

void __fastcall TfrmStatementEditor::memTrueStatementDragOver(
      TObject *Sender, TObject *Source, int X, int Y, TDragState State,
      bool &Accept)
{
   Accept = Source->ClassNameIs("TServletMethodDragObject");
}
//---------------------------------------------------------------------------


void __fastcall TfrmStatementEditor::memIfStatementDragOver(
      TObject *Sender, TObject *Source, int X, int Y, TDragState State,
      bool &Accept)
{
   Accept = Source->ClassNameIs("TConnectorObjectFieldDragObject") || Source->ClassNameIs("TBusinessObjectFieldDragObject");
}
//---------------------------------------------------------------------------



void __fastcall TfrmStatementEditor::memIfStatementDragDrop(
      TObject *Sender, TObject *Source, int X, int Y)
{
   if (Source->ClassNameIs("TConnectorObjectFieldDragObject")) {
      TConnectorObjectFieldDragObject* cofdo = dynamic_cast<TConnectorObjectFieldDragObject*>(Source);
      String mapstring = cofdo->Connector->getName()+"."+cofdo->ConnectorObject->getName()+"."+cofdo->ConnectorObjectField->getName();
      if (dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Count == 0)
         dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Add("if "+mapstring);
      else {
         String str = dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Strings[0];
         if (str.Length())
            str = str + " ";
         str = str + mapstring;
         dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Strings[0] = str;
      }
   }
   if (Source->ClassNameIs("TBusinessObjectFieldDragObject")) {
      TBusinessObjectFieldDragObject* bofdo = dynamic_cast<TBusinessObjectFieldDragObject*>(Source);
      String fieldname = bofdo->FieldName;
      if (dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Count == 0)
         dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Add("if "+fieldname);
      else {
         String str = dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Strings[0];
         if (str.Length())
            str = str + " ";
         str = str + fieldname;
         dynamic_cast<TDCMemo*>(Sender)->MemoSource->Lines->Strings[0] = str;
      }
   }
}
//---------------------------------------------------------------------------

