//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OBJBusinessObject.h"
#include "OBJBusinessObjectField.h"
#include "OBJConditionalObject.h"
#include "OBJConnection.h"
#include "OBJConnector.h"
#include "OBJConnectorObject.h"
#include "OBJConnectorObjectField.h"
#include "OBJServletMethod.h"
#include "OBJConnectorObjectDragObject.h"
#include "OBJConnectorObjectFieldDragObject.h"
#include "OBJServletMethodDragObject.h"
#include "OBJServletParam.h"
#include "OBJTextObject.h"
#include "OBJTransaction.h"
#include "OBJTransformer.h"

#include "UICommandScriptViewer.h"
#include "UIMain.h"
#include "UIObjectInspector.h"
//#include "UIObjectInspector2.h"
#include "UIObjectToolbar.h"
#include "UISetName.h"
#include "UITransactionEditor.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "kaiConnection"
#pragma link "ElPanel"
#pragma link "advpanel"
#pragma link "ElPopBtn"
#pragma link "Placemnt"
#pragma link "KnurlyControl"
#pragma link "ElPanel"
#pragma link "ElPanel"
#pragma resource "*.dfm"

TfrmTransactionEditor *TfrmTransactionEditor::_instance = 0;

//---------------------------------------------------------------------------
__fastcall TfrmTransactionEditor::TfrmTransactionEditor(TComponent* Owner)
        : TForm(Owner)
{
   d_InspectorList = new TStringList();
   KnurlyControl1->KnurlOrientation = koHorizontal;
   frmMain->aDesignEnvironmentOptions->Visible = true;
   frmMain->Save1->Enabled = true;
   frmMain->SaveAll1->Enabled = true;
   frmMain->SaveAs1->Enabled = true;
   frmMain->Close1->Enabled = true;
   frmMain->CloseAll1->Enabled = true;
   frmMain->Debug1->Visible = true;
   
}



//---------------------------------------------------------------------------
TfrmTransactionEditor* TfrmTransactionEditor::Instance(TComponent* Owner)
{
   if (_instance == 0) {
      _instance= new TfrmTransactionEditor(Owner);
   }
   return _instance;
}


//---------------------------------------------------------------------------
__fastcall TfrmTransactionEditor::~TfrmTransactionEditor()
{
   _instance = 0;
   delete d_InspectorList;
   frmMain->aDesignEnvironmentOptions->Visible = false;
   frmMain->Save1->Enabled = false;
   frmMain->SaveAll1->Enabled = false;
   frmMain->SaveAs1->Enabled = false;
   frmMain->Close1->Enabled = false;
   frmMain->CloseAll1->Enabled = false;
   frmMain->Debug1->Visible = false;
}


//---------------------------------------------------------------------------
String __fastcall TfrmTransactionEditor::getAvailableUnnamedID(TStrings* list, const String& prefix)
// Creates a unique, sequential name to display in the tab for brand new transactions.
{
   int i = 1;
   while (list->IndexOf(prefix + IntToStr(i)) >= 0)
      ++i;
   return prefix + IntToStr(i);
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::SMAddTransactionHandler(TMessage &msg)
{
   TTransaction* to = (TTransaction*)msg.LParam;

   if (!to->getCode().Length()) {                                           // is this a brand new transaction object (indicated by missing code ID)?
      to->setCode(to->makeCode());                                          // ... yes; create a ref-ID for it
      to->setName(getAvailableUnnamedID(TabControl1->Tabs, "BusinessProcess")); // ... and create a sequencial "Unnamed Transaction" ID for the tab name
   }

   bool AllowChange;
   if (TabControl1->Tabs->Count > 0)
      TabControl1Changing(TabControl1, AllowChange);
   TabControl1->TabIndex = TabControl1->Tabs->AddObject(to->getName(), to);
   d_CurrentTransaction = to;
   TabControl1Change(TabControl1);

   TfrmObjectToolbar* ot = TfrmObjectToolbar::Instance(this);
   if (Panel2->DockClientCount == 0)
      ot->ManualDock(Panel2, NULL, alLeft);
   ot->Show();
}

//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::SMShowObjectToolboxHandler(TMessage &msg)
{
   if (msg.WParam) {
      TfrmObjectToolbar* ot = TfrmObjectToolbar::Instance(this);
      ot->Show();
   }
}

//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   _instance = NULL;
   Action = caFree;
}

//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::positionPanel(TAdvPanel* pnl, int left, int top, int width, int height)
{
   pnl->Top = top;
   pnl->Left = left;
   pnl->Width = width;
   pnl->Height = height;
   TabControl1->BringToFront();
   Panel2->BringToFront();
   Panel3->BringToFront();
   Panel4->BringToFront();
   Panel5->BringToFront();
}

//---------------------------------------------------------------------------
void  __fastcall TfrmTransactionEditor::drawConnection(TConnection* co, TAdvPanel* pnl1, TAdvPanel* pnl2, TColor color)
{
   TkaiConnector* conn = new TkaiConnector(ScrollBox1); //this);
   conn->Parent = ScrollBox1; //this;
   conn->Anchors >> akLeft;
   conn->Anchors >> akRight;
   conn->Anchors >> akTop;
   conn->Anchors >> akBottom;
   conn->Tag = (long)co;
   conn->Caption = "";
   conn->LineColor = color;
   conn->LineWidth = 2;
   conn->Arrows->BeginSize = 14;
   conn->Arrows->EndSize = 14;
   conn->Control1 = pnl1->Name;
   conn->Control2 = pnl2->Name;
   conn->PopupMenu = PopupMenu1;
   conn->OnContextPopup = ConnectionContextPopup;
   switch (co->getDirection()) {
      case cdInbound:
         conn->Arrows->BeginStyle = asArrow;
         conn->Arrows->EndStyle = asNoArrow;
         break;
      case cdOutbound:
         conn->Arrows->BeginStyle = asNoArrow;
         conn->Arrows->EndStyle = asArrow;
         break;
      case cdBidirectional:
         conn->Arrows->BeginStyle = asArrow;
         conn->Arrows->EndStyle = asArrow;
         break;
      case cdNone:
         conn->Arrows->BeginStyle = asNoArrow;
         conn->Arrows->EndStyle = asNoArrow;
         conn->LineStyle = lsSquareDot;
   }
   TabControl1->BringToFront();
   Panel2->BringToFront();
   Panel3->BringToFront();
   Panel4->BringToFront();
   Panel5->BringToFront();
}

//---------------------------------------------------------------------------
TAdvPanel* __fastcall TfrmTransactionEditor::insertPanel(TColor color, TConnectableObject* pe, TImage* image)
{
   TAdvPanel* pnl = new TAdvPanel(ScrollBox1); //this);
   pnl->Name = pe->getName();
   pnl->Parent = ScrollBox1; //this;
   pnl->CanSize = true;
   pnl->CanMove = true;
   pnl->Anchors >> akLeft;
   pnl->Anchors >> akRight;
   pnl->Anchors >> akTop;
   pnl->Anchors >> akBottom;

   pnl->Caption->Text = "<B>"+pe->getName()+"</B>";
   pnl->Caption->Color = color;
   pnl->Caption->Visible = true;
   pnl->Caption->CloseButton = true;
   pnl->Caption->CloseButtonColor = clMaroon;
   pnl->Caption->Color = (TColor)(color - (RGB(15,15,15)));
   pnl->Caption->Height = 16;
//   pnl->Caption->MinMaxButton = true;
//   pnl->Caption->MinMaxButtonColor = clBlue;
   pnl->Constraints->MinWidth = 150;
   pnl->Constraints->MinHeight = 52;
   pnl->OnClose = AdvPanelClose;
   pnl->OnMouseDown = ControlMouseDown;
   pnl->OnMouseMove = ControlMouseMove;
   pnl->OnMouseUp = ControlMouseUp;
   pnl->OnResize = AdvPanelResize;
   pnl->OnDblClick = AdvPanelDblClick;
//   pnl->OnMaximize = AdvPanelMaximize;
//   pnl->OnMinimize = AdvPanelMinimize;
   pnl->PopupMenu = PopupMenu1;
   pnl->OnContextPopup = AdvPanelContextPopup;
   if (image) {
      TImage* img = new TImage(pnl);
      img->Parent = pnl;
      img->Top = 18;
      img->Left = 2;
      img->AutoSize = true;
      img->Transparent = true;
      img->Picture->Assign(image->Picture);
      if (pe->ClassNameIs("TBusinessObject")) {
         img->OnDragOver = BusinessObjectDragOver;
         img->OnDragDrop = BusinessObjectDragDrop;
      }
      img->OnMouseDown = ControlMouseDown;
      img->OnMouseMove = ControlMouseMove;
      img->OnMouseUp = ControlMouseUp;
      img->OnDblClick = AdvPanelDblClick;
   }
   pnl->Tag = (long)pe;
   pnl->Color = color;
   TabControl1->BringToFront();
   Panel2->BringToFront();
   Panel3->BringToFront();
   Panel4->BringToFront();
   Panel5->BringToFront();
   return pnl;
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::ControlMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   TfrmObjectToolbar* frmObjectToolbar = TfrmObjectToolbar::Instance(this);
   if (frmObjectToolbar->btnConnection->Down) {
      TControl* control = dynamic_cast<TControl*>(Sender);
      TPoint point = ScrollBox1->ScreenToClient(control->ClientToScreen(Point(X, Y)));
      Panel3MouseUp(Sender, Button, Shift, point.x, point.y);
   }
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::Panel3MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   TfrmObjectToolbar* frmObjectToolbar = TfrmObjectToolbar::Instance(this);
   if (Button == mbRight && !ScrollBox1->ControlAtPos(TPoint(X, Y), true, true)) {
      d_CurrentObject = d_CurrentTransaction;
      DeleteConnection1->Visible = false;
      GenerateCommandScript1->Visible = true;
      SetBreakpoint1->Visible = false;
      TPoint pt = ScrollBox1->ClientToScreen(Point(X, Y));
      PopupMenu1->Popup(pt.x, pt.y);
      return;
   }

   if (Button == mbLeft) {
      if (d_Dragging) {
         if (frmObjectToolbar->btnConnection->Down) {
            if (d_ForcedConnectionBtnDown)
               frmObjectToolbar->ToolBar1->Buttons[d_SavedDownButtonIdx]->Down = true;

            drawLine();
            d_End = Point(X, Y);
            TControl* ctrl = ScrollBox1->ControlAtPos(d_End, true, true);
            if (ctrl && ctrl != d_SourcePanel && String(ctrl->ClassName()).UpperCase() != "TKAICONNECTOR") {
               TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(ctrl);
               TConnectableObject* co = (TConnectableObject*)pnl->Tag;

//               if (!(d_SourceObject->ClassNameIs("TTextObject") || co->ClassNameIs("TTextObject") ||
//                   d_SourceObject->ClassNameIs("TConditionalObject") || co->ClassNameIs("TConditionalObject"))) {
//                  d_Dragging = false;
//                  return;
//               }

               TConnection* conn = new TConnection();
               conn->setCode(conn->makeCode());
               conn->setName(co->getName());
               conn->setSource(d_SourceObject);
               conn->setOtherEnd(co);
               if (String(co->ClassName()).UpperCase() == "TTEXTOBJECT" ||
                   String(d_SourceObject->ClassName()).UpperCase() == "TTEXTOBJECT" ||
                   String(co->ClassName()).UpperCase() == "TCONDITIONALOBJECT" ||
                   String(d_SourceObject->ClassName()).UpperCase() == "TCONDITIONALOBJECT")
                  conn->setDirection(cdNone);
               else
                  conn->setDirection(cdOutbound);
               TColor color = clSilver;
               conn->setGUIColor(color);
               d_SourceObject->getConnections()->addItem(conn);
               TConnection* conn2 = new TConnection();
               conn2->setCode(conn->makeCode());
               conn2->setName(d_SourceObject->getName());
               conn2->setSource(co);
               conn2->setOtherEnd(d_SourceObject);
               if (conn->getDirection() == cdNone)
                  conn2->setDirection(cdNone);
               else
                  conn2->setDirection(cdInbound);
               conn2->setGUIColor(color);
               co->getConnections()->addItem(conn2);
               drawConnection(conn, d_SourcePanel, pnl, color);
               SendMessage(frmObjectToolbar->Handle, smObjectPlaced, 0, 0);
               if (frmCommandScriptViewer)
                  GenerateCommandScript1Click(this);
            }
            d_Dragging = false;
            return;
         }
         else {
            ScrollBox1->Canvas->DrawFocusRect(d_Rect);
            d_Dragging = false;
         }
      }


      if (d_X >= 0 && d_Y >= 0) {
         if (frmObjectToolbar->btnBusinessObject->Down) {
            TBusinessObject* bo = new TBusinessObject();
            bo->setCode(bo->makeCode());
            bo->setName(getAvailableUnnamedID(const_cast<TStringList*>(d_CurrentTransaction->getBusinessObjects()->getNameStrings()), "BusinessObject"));
//            TAdvPanel* pnl = insertPanel((TColor)RGB(175, 215, 255), bo, Image1);
            TAdvPanel* pnl = insertPanel(bo->getGUIColor(), bo, Image1);
            positionPanel(pnl, min(d_X, X), min(d_Y, Y), max(abs(d_X - X), 150), max(abs(d_Y - Y), 52));
            pnl->OnDragOver = BusinessObjectDragOver;
            pnl->OnDragDrop = BusinessObjectDragDrop;
            bo->setGUITop(pnl->Top);
            bo->setGUILeft(pnl->Left);
            bo->setGUIWidth(pnl->Width);
            bo->setGUIHeight(pnl->Height);
            TLabel* lbl = new TLabel(pnl);
            lbl->OnDragOver = BusinessObjectDragOver;
            lbl->OnDragDrop = BusinessObjectDragDrop;
            lbl->OnDblClick = AdvPanelDblClick;
            lbl->Parent = pnl;
            lbl->Top = 18;
            lbl->Left = 34;
            lbl->Width = pnl->ClientWidth-38;
            lbl->Height = pnl->ClientHeight-32;
            lbl->AutoSize = false;
            lbl->WordWrap = true;
            lbl->Font->Name = "Small Fonts";
            lbl->Font->Color = clBlue;
            lbl->Font->Size = 7;
            d_CurrentTransaction->getBusinessObjects()->addItem(bo);
         }

         if (frmObjectToolbar->btnConnector->Down) {
            TConnector* co = new TConnector();
            co->setCode(co->makeCode());
            co->setName(getAvailableUnnamedID(const_cast<TStringList*>(d_CurrentTransaction->getConnectors()->getNameStrings()), "Connector"));
            TAdvPanel* pnl = insertPanel(co->getGUIColor(), co, Image2);
            positionPanel(pnl, min(d_X, X), min(d_Y, Y), max(abs(d_X - X), 150), max(abs(d_Y - Y), 52));
            co->setGUITop(pnl->Top);
            co->setGUILeft(pnl->Left);
            co->setGUIWidth(pnl->Width);
            co->setGUIHeight(pnl->Height);
            bool found = false;
            for (TConnectorCollection::CI cci = ConnectorCollection->begin(); cci != ConnectorCollection->end(); ++cci)
               if (!d_CurrentTransaction->getConnectors()->findName(cci->second->getName())) {
                    found = true;
                    TConnector* cnn = cci->second; //((TConnector*)cb->Items->Objects[0]);
                    co->setName(cnn->getName());
                    pnl->Name = cnn->getName();
                    pnl->Caption->Text = "<B>"+ cnn->getName() + "</B>";
                    for (TConnectorObjectCollection::CI coi = cnn->getObjects()->begin(); coi != cnn->getObjects()->end(); ++coi) {
                       TConnectorObject* newconn = new TConnectorObject(co, coi->first, coi->first);
                       String tmp = coi->first;
                       co->getObjects()->addItem(newconn);
                       for (TConnectorObjectFieldCollection::CI cofi = coi->second->getFields()->begin(); cofi != coi->second->getFields()->end(); ++cofi)
                          newconn->getFields()->addItem(new TConnectorObjectField(cofi->first, cofi->first));
                       for (TServletMethodCollection::CI comi = coi->second->getMethods()->begin(); comi != coi->second->getMethods()->end(); ++comi)
                          newconn->getMethods()->addItem(new TServletMethod(comi->first, comi->first));
                    }
                    for (TServletParamCollection::CI cpi = cnn->getParams()->begin(); cpi != cnn->getParams()->end(); ++cpi) {
                       TServletParam* newparam = new TServletParam(cpi->second->getCode(), cpi->second->getName());
                       co->getParams()->addItem(newparam);
                    }
                    break;
                 }

            if (!found) {
               delete co;
               delete pnl;
               Application->MessageBox("There are no more unreferenced connectors left!", "Out of connectors", MB_OK);
               return;
            }

            d_CurrentTransaction->getConnectors()->addItem(co);
         }

         if (frmObjectToolbar->btnTransformer->Down) {
            TTransformer* tr = new TTransformer();
            tr->setCode(tr->makeCode());
            tr->setName(getAvailableUnnamedID(const_cast<TStringList*>(d_CurrentTransaction->getTransformers()->getNameStrings()), "Transformer"));
            TAdvPanel* pnl = insertPanel(tr->getGUIColor(), tr, Image4);
            positionPanel(pnl, min(d_X, X), min(d_Y, Y), max(abs(d_X - X), 150), max(abs(d_Y - Y), 52));
            tr->setGUITop(pnl->Top);
            tr->setGUILeft(pnl->Left);
            tr->setGUIWidth(pnl->Width);
            tr->setGUIHeight(pnl->Height);
            bool found = false;
            for (TTransformerCollection::CI cci = TransformerCollection->begin(); cci != TransformerCollection->end(); ++cci)
               if (!d_CurrentTransaction->getTransformers()->findName(cci->second->getName())) {
                    found = true;
                    TTransformer* trn = cci->second; //((TTransformer*)cb->Items->Objects[0]);
                    tr->setName(trn->getName());
                    pnl->Name = trn->getName();
                    pnl->Caption->Text = "<B>"+ trn->getName() + "</B>";
//                    for (TTransformerObjectCollection::CI coi = cnn->getObjects()->begin(); coi != cnn->getObjects()->end(); ++coi) {
//                       TTransformerObject* newconn = new TTransformerObject(co, coi->first, coi->first);
//                       String tmp = coi->first;
//                       tr->getObjects()->addItem(newconn);
//                       for (TTransformerObjectFieldCollection::CI cofi = coi->second->getFields()->begin(); cofi != coi->second->getFields()->end(); ++cofi)
//                          newconn->getFields()->addItem(new TTransformerObjectField(cofi->first, cofi->first));
                       for (TServletMethodCollection::CI comi = trn->getMethods()->begin(); comi != trn->getMethods()->end(); ++comi)
                          tr->getMethods()->addItem(new TServletMethod(comi->first, comi->first));
//                    }
                    for (TServletParamCollection::CI cpi = trn->getParams()->begin(); cpi != trn->getParams()->end(); ++cpi) {
                       TServletParam* newparam = new TServletParam(cpi->second->getCode(), cpi->second->getName());
                       tr->getParams()->addItem(newparam);
                    }
                    break;
               }

            if (!found) {
               delete tr;
               delete pnl;
               Application->MessageBox("There are no more unreferenced Transformers left!", "Out of Transformers", MB_OK);
               return;
            }

            d_CurrentTransaction->getTransformers()->addItem(tr);
         }

         if (frmObjectToolbar->btnConditional->Down) {
            TConditionalObject* co = new TConditionalObject();
            co->setCode(co->makeCode());
            co->setName(getAvailableUnnamedID(const_cast<TStringList*>(d_CurrentTransaction->getConditionalObjects()->getNameStrings()), "Conditional"));
            TAdvPanel* pnl = insertPanel(co->getGUIColor(), co, Image3);
            positionPanel(pnl, min(d_X, X), min(d_Y, Y), max(abs(d_X - X), 150), max(abs(d_Y - Y), 52));
            co->setGUITop(pnl->Top);
            co->setGUILeft(pnl->Left);
            co->setGUIWidth(pnl->Width);
            co->setGUIHeight(pnl->Height);
            TLabel* lbl = new TLabel(pnl);
            lbl->Parent = pnl;
            lbl->Top = 18;
            lbl->Left = 34;
            lbl->AutoSize = false;
            lbl->WordWrap = true;
            lbl->Width = pnl->ClientWidth-38;
            lbl->Height = pnl->ClientHeight-32;
            lbl->Font->Name = "Small Fonts";
            lbl->Font->Color = clBlue;
            lbl->Font->Size = 7;
            lbl->Caption = co->getIfStatement()->Text;
            lbl->OnDblClick = AdvPanelDblClick;
            d_CurrentTransaction->getConditionalObjects()->addItem(co);
         }



         if (frmObjectToolbar->btnText->Down) {
            TTextObject* txt = new TTextObject();
            txt->setCode(txt->makeCode());
            txt->setName(getAvailableUnnamedID(const_cast<TStringList*>(d_CurrentTransaction->getTextObjects()->getNameStrings()), "Text"));
            txt->setGUILock(false);
            TAdvPanel* pnl = insertPanel(txt->getGUIColor(), txt, NULL);
            positionPanel(pnl, min(d_X, X), min(d_Y, Y), max(abs(d_X - X), 150), max(abs(d_Y - Y), 52));
            TElSpeedButton* elbtn = new TElSpeedButton(pnl);
            elbtn->Parent = pnl;
            elbtn->Top = 21;
            elbtn->Left = 2;
            elbtn->Width = 16;
            elbtn->Height = 16;
            elbtn->Flat = true;
            elbtn->Tag = 0;
            elbtn->NormalImage = pushopenImageBlue->Picture->Bitmap;
            elbtn->MouseInImage = pushopenImageRed->Picture->Bitmap;
            elbtn->PressedImage = pushopenImageRed->Picture->Bitmap;
            elbtn->OnClick = PushBtnClick;
            elbtn->TransparentColor = clWhite;
            elbtn->Visible = true;

            TMemo* mem = new TMemo(pnl);
            mem->Parent = pnl;
            mem->Top = 18;
            mem->Left = 15;
            mem->Width = pnl->ClientWidth-19;
            mem->Height = pnl->ClientHeight - 32;
            mem->ScrollBars = ssVertical;
            mem->Lines->Clear();
            mem->OnChange = Memo1Change;
            d_CurrentTransaction->getTextObjects()->addItem(txt);
         }


         if (frmObjectToolbar->btnConnection->Down) {
   /*         TkaiConnector* dc = new TkaiConnector(this);
            dc->Parent = this;
            dc->Top = min(d_Y, Y);
            dc->Left = min(d_X, X);
            if (Y != d_Y)
               dc->Height = abs(d_Y - Y);
            else
               dc->Height = 72;

            if (X != d_X)
               dc->Width = abs(d_X - X);
            else
               dc->Width = 72;
            dc->Width = 100;
            dc->Height = 81;
            dc->Top = d_Y;
            dc->Left = d_X;
            dc->LineColor = clRed;
            dc->LineWidth = 2;
            dc->Caption = "";                        */
   //         kaiDesigner1->EditingControls->Add(dc->Name);
         }
         SendMessage(frmObjectToolbar->Handle, smObjectPlaced, 0, 0);
         if (frmCommandScriptViewer)
            GenerateCommandScript1Click(this);
         d_X = d_Y = -1;
      }
   }
}


void __fastcall TfrmTransactionEditor::cbConnectorChanged(TObject* Sender)
{
   // this function sends a message to the object inspector to update itself
   // so that the newly selected connectors fields & methods appear correctly.
/*
   TComboBox* cb = dynamic_cast<TComboBox*>(Sender);
   TConnector* cnn = ((TConnector*)cb->Items->Objects[cb->ItemIndex]);
   TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(cb->Parent);
   TConnector* co = (TConnector*)pnl->Tag;

   co->setName(cnn->getName());
   co->setCode(cnn->getCode());

   co->getObjects()->clearObjects();
   co->getParams()->clearObjects();

   for (TConnectorObjectCollection::CI coi = cnn->getObjects()->begin(); coi != cnn->getObjects()->end(); ++coi) {
      TConnectorObject* newconn = new TConnectorObject(co, coi->first, coi->first);
      co->getObjects()->addItem(newconn);

      for (TConnectorObjectFieldCollection::CI cofi = coi->second->getFields()->begin(); cofi != coi->second->getFields()->end(); ++cofi)
         newconn->getFields()->addItem(new TConnectorObjectField(cofi->first, cofi->first));
      for (TServletMethodCollection::CI comi = coi->second->getMethods()->begin(); comi != coi->second->getMethods()->end(); ++comi)
         newconn->getMethods()->addItem(new TServletMethod(comi->first, comi->first));
   }
   for (TConnectorParamCollection::CI cpi = cnn->getParams()->begin(); cpi != cnn->getParams()->end(); ++cpi) {
      TConnectorParam* newparam = new TConnectorParam(cpi->second->getCode(), cpi->second->getName());
      co->getParams()->addItem(newparam);
   }

   for (int i=0; i<=d_InspectorList->Count-1; i++) {
      if (d_InspectorList->Objects[i] == co) {
         ((TfrmObjectInspector*)StrToInt(d_InspectorList->Strings[i]))->rebuild(co);
         break;
      }
   }

   pnl->SetFocus();
*/
}

//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::drawLine()
{
   ScrollBox1->Canvas->Pen->Mode = pmXor;
   ScrollBox1->Canvas->Pen->Width = 1;
   ScrollBox1->Canvas->Pen->Color = clGray;
   ScrollBox1->Canvas->Pen->Style = psDot;
   ScrollBox1->Canvas->MoveTo( d_Start.x, d_Start.y );
   ScrollBox1->Canvas->LineTo( d_End.x, d_End.y );
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::ControlMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if (Button == mbLeft) {
      TfrmObjectToolbar* frmObjectToolbar = TfrmObjectToolbar::Instance(this);
      if (!frmObjectToolbar->btnConnection->Down) {
         for (int i=0; i<=frmObjectToolbar->ToolBar1->ButtonCount-1; i++)
            if (frmObjectToolbar->ToolBar1->Buttons[i]->Down) {
               d_SavedDownButtonIdx = i;
               break;
            }

         frmObjectToolbar->btnConnection->Down = true;
         frmObjectToolbar->btnMouseUp(frmObjectToolbar->btnConnection, Button, Shift, X, Y);
         d_ForcedConnectionBtnDown = true;
      }
      else
         d_ForcedConnectionBtnDown = false;
      TControl* control = dynamic_cast<TControl*>(Sender);
      TPoint point = ScrollBox1->ScreenToClient(control->ClientToScreen(Point(X, Y)));
      Panel3MouseDown(Sender, Button, Shift, point.x, point.y);
   }
}



//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::Panel3MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if (Button == mbRight) {
      return;
   }
   TfrmObjectToolbar* frmObjectToolbar = TfrmObjectToolbar::Instance(this);
   if (Button == mbLeft) {
      if (frmObjectToolbar->btnConnection->Down) {
         TControl* ctrl = ScrollBox1->ControlAtPos(Point(X, Y), true, true);
         if (ctrl && String(ctrl->ClassName()).UpperCase() == "TADVPANEL") {
            d_SourceObject = ((TConnectableObject*)dynamic_cast<TAdvPanel*>(ctrl)->Tag);
            d_SourcePanel = dynamic_cast<TAdvPanel*>(ctrl);
            d_Start = Point(X, Y);
            d_End = d_Start;
            d_Dragging = true;
            drawLine();
         }
      }
      else {
         d_X = X;
         d_Y = Y;
         d_Dragging = true;
         SetRect(&d_Rect, X, Y, X, Y);
         ScrollBox1->Canvas->DrawFocusRect(d_Rect);
      }
   }
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::ControlMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   TfrmObjectToolbar* frmObjectToolbar = TfrmObjectToolbar::Instance(this);
   if (frmObjectToolbar->btnConnection->Down) {
      TControl* control = dynamic_cast<TControl*>(Sender);
      TPoint point = ScrollBox1->ScreenToClient(control->ClientToScreen(Point(X, Y)));
      Panel3MouseMove(Sender, Shift, point.x, point.y);
   }
}



//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::Panel3MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   TfrmObjectToolbar* frmObjectToolbar = TfrmObjectToolbar::Instance(this);
   if (d_Dragging) {
      if (frmObjectToolbar->btnConnection->Down) {
         drawLine();
         if (Shift.Contains(ssLeft)) {
            d_End = Point(X,Y);
            drawLine();
         }
         else
            d_Dragging = false;
      }
      else {
         ScrollBox1->Canvas->DrawFocusRect(d_Rect);
         d_Rect.Right = X;
         d_Rect.Bottom = Y;
         ScrollBox1->Canvas->DrawFocusRect(d_Rect);
      }
   }
}

 
//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::AdvPanelClose(TObject *Sender)
{
    TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(Sender);
    TConnectableObject* pe = (TConnectableObject*)pnl->Tag;

//    if (Application->MessageBox(String("Are you sure you want to delete "+pnl->Caption->Text+"?").c_str(),
//                                "Confirm Delete",
//                                MB_YESNO) == IDYES)  {

       for (int i=0; i<=d_InspectorList->Count-1; i++)
          if (d_InspectorList->Objects[i] == pe) {
             delete ((TfrmObjectInspector*)StrToInt(d_InspectorList->Strings[i]));
             d_InspectorList->Delete(i);
             break;
          }
          

       for (TConnectionCollection::CI cci = pe->getConnections()->begin(); cci != pe->getConnections()->end(); ++cci) {
          TConnectableObject* co = cci->second->getOtherEnd();
          TConnection* conn = co->getConnections()->findName(pe->getName());
          while (conn) {
             co->getConnections()->deleteItem(conn);
             conn = co->getConnections()->findName(pe->getName());
          }
       }

       if (String(pe->ClassName()).UpperCase() == "TBUSINESSOBJECT")
          d_CurrentTransaction->getBusinessObjects()->deleteItem(pe->getCode());
       else
          if (String(pe->ClassName()).UpperCase() == "TCONNECTOR")
             d_CurrentTransaction->getConnectors()->deleteItem(pe->getCode());
          else
             if (String(pe->ClassName()).UpperCase() == "TTEXTOBJECT")
                d_CurrentTransaction->getTextObjects()->deleteItem(pe->getCode());
             else
                if (String(pe->ClassName()).UpperCase() == "TCONDITIONALOBJECT")
                   d_CurrentTransaction->getConditionalObjects()->deleteItem(pe->getCode());
                else
                   if (String(pe->ClassName()).UpperCase() == "TTRANSFORMER")
                      d_CurrentTransaction->getTransformers()->deleteItem(pe->getCode());
//       delete pe;
//    }
//     ScrollBox1->RemoveComponent(pnl);

     updateConnections();
     if (frmCommandScriptViewer)
        GenerateCommandScript1Click(this);
     PostMessage(Handle, smDeleteComp, 0, (long)pnl);
}


void __fastcall TfrmTransactionEditor::SMDeleteCompHandler(TMessage& msg)
{
   TComponent* comp = (TComponent*)msg.LParam;
   delete comp;
}

//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::AdvPanelResize(TObject *Sender)
{
   // Save the position & size of the GUI representations of an object after the user moves it....

   TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(Sender);
   TConnectableObject* pe = (TConnectableObject*)pnl->Tag;
   pe->setGUITop(pnl->Top);
   pe->setGUILeft(pnl->Left);
   pe->setGUIWidth(pnl->Width);
   pe->setGUIHeight(pnl->Height);


   if (String(pe->ClassName()).UpperCase() == "TTEXTOBJECT") {
      TTextObject* to = dynamic_cast<TTextObject*>(pe);
      for (int i=0; i<=pnl->ComponentCount-1; i++) {
         TComponent* comp = pnl->Components[i];
         if (String(comp->ClassName()).UpperCase() == "TMEMO") {
            TMemo* mem = dynamic_cast<TMemo*>(comp);
            mem->Width = pnl->ClientWidth-19;
            if (pnl->Caption->Visible)
               mem->Height = pnl->ClientHeight-32;
            else
               mem->Height = pnl->ClientHeight - 4;
            to->getText()->Clear();
            to->getText()->AddStrings(mem->Lines);
         }
      }
   }
//   if (String(pe->ClassName()).UpperCase() == "TCONNECTOR") {
//      TConnector* co = dynamic_cast<TConnector*>(pe);
//     for (int i=0; i<=pnl->ComponentCount-1; i++) {
//         TComponent* comp = pnl->Components[i];
//         if (String(comp->ClassName()).UpperCase() == "TLABEL") {
//            TLabel* lbl = dynamic_cast<TLabel*>(comp);
//            lbl->Width = pnl->ClientWidth-38;
//            lbl->Height = pnl->ClientWidth-32;
//         }
//      }
//   }

   if (String(pe->ClassName()).UpperCase() == "TCONDITIONALOBJECT") {
      for (int i=0; i<=pnl->ComponentCount-1; i++) {
         TComponent* comp = pnl->Components[i];
         if (String(comp->ClassName()).UpperCase() == "TLABEL") {
            TLabel* lbl = dynamic_cast<TLabel*>(comp);
            lbl->Width = pnl->ClientWidth-38;
            lbl->Height = pnl->ClientHeight-32;
         }
      }
   }

   if (String(pe->ClassName()).UpperCase() == "TBUSINESSOBJECT") {
      for (int i=0; i<=pnl->ComponentCount-1; i++) {
         TComponent* comp = pnl->Components[i];
         if (String(comp->ClassName()).UpperCase() == "TLABEL") {
            TLabel* lbl = dynamic_cast<TLabel*>(comp);
            lbl->Width = pnl->ClientWidth-38;
            lbl->Height = pnl->ClientHeight-32;
         }
      }
   }

}

//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::updateConnections()
{

   for (int i = ScrollBox1->ComponentCount-1; i >= 0; i--) {
      TComponent* comp = ScrollBox1->Components[i];
      if (String(comp->ClassName()).UpperCase() == "TKAICONNECTOR")
         delete comp;
   }

   for (TBusinessObjectCollection::CI boci =  d_CurrentTransaction->getBusinessObjects()->begin();
                                      boci != d_CurrentTransaction->getBusinessObjects()->end();
                                      ++boci) {
      TAdvPanel *pnl1, *pnl2;

      for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
         if (ScrollBox1->Components[i]->Tag == (long)boci->second) {
            pnl1 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
            break;
         }

      for (TConnectionCollection::CI cci = boci->second->getConnections()->begin();
                                     cci !=boci->second->getConnections()->end();
                                     ++cci) {
         if (cci->second->getDirection() == cdOutbound || cci->second->getDirection() == cdNone) {
            for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
               if (ScrollBox1->Components[i]->Tag == (long)cci->second->getOtherEnd()) {
                  pnl2 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
                  break;
               }

            if (pnl1 && pnl2 && pnl1 != pnl2)
               drawConnection(cci->second, pnl1, pnl2, cci->second->getGUIColor());
         }
      }
   }


   for (TConditionalObjectCollection::CI boci =  d_CurrentTransaction->getConditionalObjects()->begin();
                                      boci != d_CurrentTransaction->getConditionalObjects()->end();
                                      ++boci) {
      TAdvPanel *pnl1, *pnl2;

      for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
         if (ScrollBox1->Components[i]->Tag == (long)boci->second) {
            pnl1 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
            break;
         }

      for (TConnectionCollection::CI cci = boci->second->getConnections()->begin();
                                     cci !=boci->second->getConnections()->end();
                                     ++cci) {
         if (cci->second->getDirection() == cdOutbound || cci->second->getDirection() == cdNone) {
            for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
               if (ScrollBox1->Components[i]->Tag == (long)cci->second->getOtherEnd()) {
                  pnl2 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
                  break;
               }

            if (pnl1 && pnl2 && pnl1 != pnl2)
               drawConnection(cci->second, pnl1, pnl2, cci->second->getGUIColor());
         }
      }
   }
   

   for (TConnectorCollection::CI coci =  d_CurrentTransaction->getConnectors()->begin();
                                      coci != d_CurrentTransaction->getConnectors()->end();
                                      ++coci) {
      TAdvPanel *pnl1, *pnl2;

      for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
         if (ScrollBox1->Components[i]->Tag == (long)coci->second) {
            pnl1 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
            break;
         }

      for (TConnectionCollection::CI cci = coci->second->getConnections()->begin();
                                     cci !=coci->second->getConnections()->end();
                                     ++cci) {
         if (cci->second->getDirection() == cdOutbound || cci->second->getDirection() == cdNone) {
            for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
               if (ScrollBox1->Components[i]->Tag == (long)cci->second->getOtherEnd()) {
                  pnl2 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
                  break;
               }

            if (pnl1 && pnl2 && pnl1 != pnl2)
               drawConnection(cci->second, pnl1, pnl2, cci->second->getGUIColor());
         }
      }
   }

   for (TTransformerCollection::CI tci =  d_CurrentTransaction->getTransformers()->begin();
                                      tci != d_CurrentTransaction->getTransformers()->end();
                                      ++tci) {
      TAdvPanel *pnl1, *pnl2;

      for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
         if (ScrollBox1->Components[i]->Tag == (long)tci->second) {
            pnl1 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
            break;
         }

      for (TConnectionCollection::CI cci = tci->second->getConnections()->begin();
                                     cci !=tci->second->getConnections()->end();
                                     ++cci) {
         if (cci->second->getDirection() == cdOutbound || cci->second->getDirection() == cdNone) {
            for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
               if (ScrollBox1->Components[i]->Tag == (long)cci->second->getOtherEnd()) {
                  pnl2 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
                  break;
               }

            if (pnl1 && pnl2 && pnl1 != pnl2)
               drawConnection(cci->second, pnl1, pnl2, cci->second->getGUIColor());
         }
      }
   }


   for (TTextObjectCollection::CI toci =  d_CurrentTransaction->getTextObjects()->begin();
                                      toci != d_CurrentTransaction->getTextObjects()->end();
                                      ++toci) {
      TAdvPanel *pnl1, *pnl2;

      for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
         if (ScrollBox1->Components[i]->Tag == (long)toci->second) {
            pnl1 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
            break;
         }

      for (TConnectionCollection::CI cci = toci->second->getConnections()->begin();
                                     cci !=toci->second->getConnections()->end();
                                     ++cci) {
         if (cci->second->getDirection() == cdOutbound || cci->second->getDirection() == cdNone) {
            for (int i=0; i<=ScrollBox1->ComponentCount-1; i++)
               if (ScrollBox1->Components[i]->Tag == (long)cci->second->getOtherEnd()) {
                  pnl2 = dynamic_cast<TAdvPanel*>(ScrollBox1->Components[i]);
                  break;
               }

            if (pnl1 && pnl2 && pnl1 != pnl2)
               drawConnection(cci->second, pnl1, pnl2, cci->second->getGUIColor());
         }
      }
   }

}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::TabControl1Change(TObject *Sender)
{
   d_CurrentTransaction = ((TTransaction*)TabControl1->Tabs->Objects[TabControl1->TabIndex]);

   for (int i = ScrollBox1->ComponentCount-1; i >= 0; i--) {
      TComponent* comp = ScrollBox1->Components[i];
      if (String(comp->ClassName()).UpperCase() == "TADVPANEL" || String(comp->ClassName()).UpperCase() == "TKAICONNECTOR")
         delete comp;
   }

   for (TBusinessObjectCollection::CI boc = d_CurrentTransaction->getBusinessObjects()->begin();
         boc != d_CurrentTransaction->getBusinessObjects()->end(); ++boc) {
      TBusinessObject* bo = boc->second;
      TAdvPanel* pnl = insertPanel(bo->getGUIColor(), bo, Image1);
      pnl->OnDragOver = BusinessObjectDragOver;
      pnl->OnDragDrop = BusinessObjectDragDrop;
      positionPanel(pnl, bo->getGUILeft(), bo->getGUITop(), bo->getGUIWidth(), bo->getGUIHeight());
      TLabel* lbl = new TLabel(pnl);
      lbl->Parent = pnl;
      lbl->OnDragOver = BusinessObjectDragOver;
      lbl->OnDragDrop = BusinessObjectDragDrop;
      lbl->Top = 18;
      lbl->Left = 36;
      lbl->AutoSize = false;
      lbl->WordWrap = true;
      lbl->Height = pnl->ClientHeight-32;
      lbl->Width = pnl->ClientWidth-40;
      lbl->Font->Name = "Small Fonts";
      lbl->Font->Color = clBlue;
      lbl->Font->Size = 7;
//      lbl->Caption = co->getIfStatement();
   }

   for (TConditionalObjectCollection::CI coc = d_CurrentTransaction->getConditionalObjects()->begin();
         coc != d_CurrentTransaction->getConditionalObjects()->end(); ++coc) {
      TConditionalObject* co = coc->second;
      TAdvPanel* pnl = insertPanel(co->getGUIColor(), co, Image3);
      positionPanel(pnl, co->getGUILeft(), co->getGUITop(), co->getGUIWidth(), co->getGUIHeight());
      TLabel* lbl = new TLabel(pnl);
      lbl->Parent = pnl;
      lbl->Top = 18;
      lbl->Left = 36;
      lbl->AutoSize = false;
      lbl->WordWrap = true;
      lbl->Height = pnl->ClientHeight-32;
      lbl->Width = pnl->ClientWidth-40;
      lbl->Font->Name = "Small Fonts";
      lbl->Font->Color = clBlue;
      lbl->Font->Size = 7;
      lbl->Caption = co->getIfStatement()->Text;
   }


   for (TConnectorCollection::CI coc = d_CurrentTransaction->getConnectors()->begin();
         coc != d_CurrentTransaction->getConnectors()->end(); ++coc) {
      TConnector* co = coc->second;
      TAdvPanel* pnl = insertPanel(co->getGUIColor(), co, Image2);
      positionPanel(pnl, co->getGUILeft(), co->getGUITop(), co->getGUIWidth(), co->getGUIHeight());
   }

   for (TTransformerCollection::CI tri = d_CurrentTransaction->getTransformers()->begin();
         tri != d_CurrentTransaction->getTransformers()->end(); ++tri) {
      TTransformer* tr = tri->second;
      TAdvPanel* pnl = insertPanel(tr->getGUIColor(), tr, Image4);
      positionPanel(pnl, tr->getGUILeft(), tr->getGUITop(), tr->getGUIWidth(), tr->getGUIHeight());
   }   

   for (TTextObjectCollection::CI toc = d_CurrentTransaction->getTextObjects()->begin();
         toc != d_CurrentTransaction->getTextObjects()->end(); ++toc) {
      TTextObject* to = toc->second;
      TAdvPanel* pnl = insertPanel(to->getGUIColor(), to, NULL);
      positionPanel(pnl, to->getGUILeft(), to->getGUITop(), to->getGUIWidth(), to->getGUIHeight());
      TElSpeedButton* elbtn = new TElSpeedButton(pnl);
      elbtn->Parent = pnl;
      elbtn->Top = 21;
      elbtn->Left = 2;
      elbtn->Width = 16;
      elbtn->Height = 16;
      elbtn->Flat = true;
      elbtn->OnClick = PushBtnClick;
      if (to->getGUILock()) {
         elbtn->NormalImage = pushclosedImageBlue->Picture->Bitmap;
         elbtn->MouseInImage = pushclosedImageRed->Picture->Bitmap;
         elbtn->PressedImage = pushclosedImageRed->Picture->Bitmap;
         elbtn->Tag = 1;
         elbtn->Top -= 18;
         pnl->Caption->Visible = false;
         pnl->Caption->Height = 0;
//         pnl->Top += 16;
         pnl->Color = clWhite;
         pnl->CanMove = false;
         pnl->CanSize = false;
         pnl->BevelOuter = bvNone;
         pnl->Top += 18;
         pnl->Constraints->MinHeight -= 32;
         pnl->Height -= 32;
      }
      else {
         elbtn->NormalImage = pushopenImageBlue->Picture->Bitmap;
         elbtn->MouseInImage = pushopenImageRed->Picture->Bitmap;
         elbtn->PressedImage = pushopenImageRed->Picture->Bitmap;
         elbtn->Tag = 0;
      }
      elbtn->TransparentColor = clWhite;

      TMemo* mem = new TMemo(pnl);
      mem->Parent = pnl;
      mem->Top = 18;
      mem->Left = 15;
      mem->Width = pnl->ClientWidth-19;
      mem->Height = pnl->ClientHeight - 32;
      mem->Lines->AddStrings(to->getText());
      if (to->getGUILock()) {
         mem->BorderStyle = bsNone;
         mem->ScrollBars = ssNone;
         mem->Top = 3;
         mem->Left += 3;
         mem->ReadOnly = true;
      }
      else
         mem->ScrollBars = ssVertical;

   }

   updateConnections();

   Caption = "Business Process Modeller - " + d_CurrentTransaction->getName();

}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::PushBtnClick(TObject* Sender)
{
   TElSpeedButton* btn = dynamic_cast<TElSpeedButton*>(Sender);
   TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(btn->Parent);
   TTextObject* to = (TTextObject*)pnl->Tag;

   TMemo* mem = NULL;
   for (int i=0; i<=pnl->ComponentCount-1; i++) {
      TComponent* comp = pnl->Components[i];
      if (String(comp->ClassName()).UpperCase() == "TMEMO") {
         mem = dynamic_cast<TMemo*>(comp);
         break;
      }
   }
   switch (btn->Tag) {
      case 0:
         btn->NormalImage  = pushclosedImageBlue->Picture->Bitmap;
         btn->MouseInImage = pushclosedImageRed->Picture->Bitmap;
         btn->PressedImage = pushclosedImageRed->Picture->Bitmap;
         btn->Tag = 1;
         pnl->Color = clWhite;
         pnl->CanSize = false;
         pnl->CanMove = false;
         pnl->Caption->Visible = false;
         pnl->Top += 18;
         pnl->Constraints->MinHeight -= 32;
         pnl->Height -= 32;
//         pnl->Caption->CloseButton = false;
//         pnl->Caption->Color = clWhite;
         pnl->BevelOuter = bvNone;
         mem->BorderStyle = bsNone;
         btn->Top -= 18;
         mem->Top = 3;
         mem->Left += 3;
         mem->ReadOnly = true;
         mem->ScrollBars = ssNone;
         mem->OnEnter = memoBounce;
         to->setGUILock(true);
         pnl->SetFocus();
         break;
      case 1:
         btn->NormalImage  = pushopenImageBlue->Picture->Bitmap;
         btn->MouseInImage = pushopenImageRed->Picture->Bitmap;
         btn->PressedImage = pushopenImageRed->Picture->Bitmap;
         btn->Tag = 0;
         pnl->Color = (TColor)RGB(180, 220, 180);
         pnl->CanSize = true;
         pnl->CanMove = true;
         pnl->Caption->Visible = true;
         pnl->Top -= 18;
         pnl->Height += 32;
         pnl->Constraints->MinHeight = 52;;
//         pnl->Caption->CloseButton = true;
//         pnl->Caption->Color = (TColor)RGB(200, 170, 200) - (TColor)RGB(15, 15, 15);
         pnl->BevelOuter= bvRaised;
         mem->BorderStyle = bsSingle;
         btn->Top += 18;
         mem->Top = 18;
         mem->Left -= 3;
         mem->ReadOnly = false;
         mem->ScrollBars = ssVertical;
         mem->OnEnter = NULL;
         to->setGUILock(false);
         break;
   }
}


void __fastcall TfrmTransactionEditor::memoBounce(TObject *Sender)
{
   TabControl1->SetFocus();
}

//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::TabControl1Changing(TObject *Sender,
      bool &AllowChange)
{
   for (TBusinessObjectCollection::CI boc = d_CurrentTransaction->getBusinessObjects()->begin();
           boc != d_CurrentTransaction->getBusinessObjects()->end(); ++boc) {
      TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(FindComponent(boc->second->getName()));
      if (pnl)
         AdvPanelResize(pnl);
   }

   for (TBusinessObjectCollection::CI boc = d_CurrentTransaction->getBusinessObjects()->begin();
           boc != d_CurrentTransaction->getBusinessObjects()->end(); ++boc) {
      TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(FindComponent(boc->second->getName()));
      if (pnl)
         AdvPanelResize(pnl);
   }

   for (TConnectorCollection::CI coc = d_CurrentTransaction->getConnectors()->begin();
           coc != d_CurrentTransaction->getConnectors()->end(); ++coc) {
      TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(FindComponent(coc->second->getName()));
      if (pnl)
         AdvPanelResize(pnl);
   }
   for (TTransformerCollection::CI tri = d_CurrentTransaction->getTransformers()->begin();
           tri != d_CurrentTransaction->getTransformers()->end(); ++tri) {
      TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(FindComponent(tri->second->getName()));
      if (pnl)
         AdvPanelResize(pnl);
   }
   for (TTextObjectCollection::CI toc = d_CurrentTransaction->getTextObjects()->begin();
           toc != d_CurrentTransaction->getTextObjects()->end(); ++toc) {
      TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(FindComponent(toc->second->getName()));
      if (pnl)
         AdvPanelResize(pnl);
   }
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::AdvPanelContextPopup(
      TObject *Sender, const TPoint &MousePos, bool &Handled)
{
   d_CurrentObject = reinterpret_cast<TConnectableObject*>(dynamic_cast<TAdvPanel*>(Sender)->Tag);
   d_CurrentPanel = dynamic_cast<TAdvPanel*>(Sender);
   DeleteConnection1->Visible = false;
   GenerateCommandScript1->Visible = false;
   SetBreakpoint1->Visible = true;
   Handled = false;
}


void __fastcall TfrmTransactionEditor::AdvPanelDblClick(TObject* Sender)
{
   if (!Sender->ClassNameIs("TAdvPanel"))
      Sender = dynamic_cast<TControl*>(Sender)->Parent;

   d_CurrentObject = reinterpret_cast<TConnectableObject*>(dynamic_cast<TAdvPanel*>(Sender)->Tag);
   d_CurrentPanel = dynamic_cast<TAdvPanel*>(Sender);
   Properties1Click(Configure1);
}

//---------------------------------------------------------------------------



void __fastcall TfrmTransactionEditor::Properties1Click(TObject *Sender)
{
//   TConnectableObject* pe = d_CurrentObject; //(TConnectableObject*)d_CurrentPanel->Tag;
   for (int i=0; i<=d_InspectorList->Count-1; i++)
       if (d_InspectorList->Objects[i] == d_CurrentObject) {
           ((TfrmObjectInspector*)StrToInt(d_InspectorList->Strings[i]))->Show();
           return;
       }
   TfrmObjectInspector* fe = new TfrmObjectInspector(this, d_CurrentObject);
   if (d_CurrentObject->ClassNameIs("TTransaction"))
      fe->rmInspector1->Color = clBtnFace;
   else
      fe->rmInspector1->Color = d_CurrentPanel->Color;

   d_InspectorList->AddObject(IntToStr((long)fe), d_CurrentObject);

   if (!d_CurrentObject->ClassNameIs("TTransaction")) {
      int thismid = d_CurrentPanel->Height / 2;
      int femid = fe->Height / 2;
      TPoint pt = d_CurrentPanel->ClientToScreen(TPoint(0, thismid));
      if (pt.y - femid < 0)
         fe->Top = 0;
      else
         fe->Top = pt.y - femid;
      fe->Left = d_CurrentPanel->Left;
   }
   fe->Show();
   fe->BringToFront();
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::Memo1Change(TObject *Sender)
{
   TMemo* memo = dynamic_cast<TMemo*>(Sender);
   TAdvPanel* pnl = ((TAdvPanel*)memo->Parent);
   TTextObject* txt = ((TTextObject*)pnl->Tag);
   txt->getText()->Clear();
   txt->getText()->AddStrings(memo->Lines);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::ApplicationEvents1Hint(
      TObject *Sender)
{
   StatusBar1->SimpleText = GetLongHint(Application->Hint);
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::FormContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
   d_CurrentObject = d_CurrentTransaction;
   DeleteConnection1->Visible = false;
   GenerateCommandScript1->Visible = true;
   SetBreakpoint1->Visible = false;
   Handled = false;
}
//---------------------------------------------------------------------------


void __fastcall TfrmTransactionEditor::ConnectionContextPopup(TObject *Sender, const TPoint &MousePos, bool &Handled)
{
   TConnection* conn = ((TConnection*)dynamic_cast<TkaiConnector*>(Sender)->Tag);
   d_CurrentConnection = dynamic_cast<TkaiConnector*>(Sender);
   d_CurrentObject = conn;
   DeleteConnection1->Visible = true;
   GenerateCommandScript1->Visible = false;
   SetBreakpoint1->Visible = false;
   Handled = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::DeleteConnection1Click(
      TObject *Sender)
{
   TConnection* conn = (TConnection*)d_CurrentConnection->Tag;
   TConnectableObject* co1 = conn->getSource();
   TConnectableObject* co2 = conn->getOtherEnd();
   String name1 = co1->getName();
   String name2 = co2->getName();
   TConnection* cx = co1->getConnections()->findName(name1);
   if (cx)
      co1->getConnections()->deleteItem(cx);

   cx = co2->getConnections()->findName(name2);
   if (cx)
      co2->getConnections()->deleteItem(cx);

   delete d_CurrentConnection;
   if (frmCommandScriptViewer)
      GenerateCommandScript1Click(this);
}
//---------------------------------------------------------------------------

TAdvPanel* __fastcall TfrmTransactionEditor::findPanel(TConnectableObject* co)
{
   for (int i = 0; i <= ScrollBox1->ComponentCount-1; i++) {
      TComponent* comp = ScrollBox1->Components[i];
      if (comp->Tag == (long)co)
         return dynamic_cast<TAdvPanel*>(comp);
   }
   return NULL;
}



//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::SMObjectPropertiesChangedHandler(TMessage& msg)
{
   TConnectableObject* co = (TConnectableObject*)msg.LParam;
   String classname = co->ClassName();

   if (classname.UpperCase() == "TCONNECTION") {
      updateConnections();
   }
   else {
      TAdvPanel* pnl = findPanel(co);
      if (pnl) {
         pnl->Caption->Text = "<B>"+co->getName()+"</B>";
         pnl->Name = co->getName();
      }
      if (classname.UpperCase() == "TCONDITIONALOBJECT") {
         for (int i=0; i<=pnl->ComponentCount-1; i++)
            if (String(pnl->Components[i]->ClassName()).UpperCase() == "TLABEL") {
               dynamic_cast<TLabel*>(pnl->Components[i])->Caption = dynamic_cast<TConditionalObject*>(co)->getIfStatement()->Text;
               break;
            }
      }
   }
   if (frmCommandScriptViewer)
      GenerateCommandScript1Click(this);
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::SMObjectNameChangedHandler(TMessage& msg)
{
   TNAMEINFO* name_info = (TNAMEINFO*)msg.LParam;
   if (name_info->obj == d_CurrentTransaction) {
      TabControl1->Tabs->Strings[TabControl1->TabIndex] = name_info->name;
      name_info->obj->setName(name_info->name);
   }
   else {
      TAdvPanel* pnl = findPanel(name_info->obj);
      if (pnl) {
         pnl->Caption->Text = "<B>"+name_info->name+"</B>";
         pnl->Name = name_info->name;
         name_info->obj->setName(name_info->name);
      }
   }
   delete name_info;
}



//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::BusinessObjectDragOver(TObject *Sender,
       TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
   Accept = false;
   if (d_ProcessingDrag)
      return;
   d_ProcessingDrag = true;
   if (Source->ClassType() == __classid(TConnectorObjectDragObject))
      Accept = true;
   if (Source->ClassType() == __classid(TConnectorObjectFieldDragObject) || Source->ClassType() == __classid(TServletMethodDragObject)) {
      if (!Sender->ClassNameIs("TAdvPanel"))
         Sender = dynamic_cast<TControl*>(Sender)->Parent;

      TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(Sender);
      TBusinessObject* bo = (TBusinessObject*)pnl->Tag;

      TfrmObjectInspector* fe;
      int idx = d_InspectorList->IndexOfObject(bo);
      if (idx < 0) {
         fe = new TfrmObjectInspector(this, bo);
         fe->rmInspector1->Color = pnl->Color;
         d_InspectorList->AddObject(IntToStr((long)fe), bo);
         int thismid = pnl->Height / 2;
         int femid = fe->Height / 2;
         TPoint pt = pnl->ClientToScreen(TPoint(0, thismid));
         if (pt.y - femid < 0)
            fe->Top = 0;
         else
            fe->Top = pt.y - femid;
         fe->Left = pnl->Left;
         fe->Show();
         fe->BringToFront();
      }

      Application->ProcessMessages();
   }
   d_ProcessingDrag = false;
}


//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::BusinessObjectDragDrop(TObject *Sender,
      TObject *Source, int X, int Y)
{
   if (Sender->ClassNameIs("TLabel") || Sender->ClassNameIs("TImage"))
      Sender = dynamic_cast<TControl*>(Sender)->Parent;

   TConnectorObjectDragObject* codo = dynamic_cast<TConnectorObjectDragObject*>(Source);

   TAdvPanel* pnl = dynamic_cast<TAdvPanel*>(Sender);
   TBusinessObject* bo = ((TBusinessObject*)pnl->Tag);

   bo->addObjectFields(codo->ConnectorObject);
   bo->getObjects()->Add(codo->ConnectorObject->getName());

   if (Source->ClassType() == __classid(TConnectorObjectDragObject)) {
      for (int i=0; i<=pnl->ComponentCount-1; i++)
         if (String(pnl->Components[i]->ClassName()).UpperCase() == "TLABEL") {
            TLabel* lbl = dynamic_cast<TLabel*>(pnl->Components[i]);
            if (lbl->Caption.Length())
               lbl->Caption = lbl->Caption + ", ";
            lbl->Caption = lbl->Caption + codo->ConnectorObject->getName(); 
            break;
         }

      for (TConnectionCollection::CI ci = bo->getConnections()->begin(); ci != bo->getConnections()->end(); ++ci) {
         TConnection* conn = ci->second;
         if (conn->getDirection() == cdOutbound) {
            conn->setGUIColor(clRed);
            TConnection* conn2 = conn->getOtherEnd()->getConnections()->findName(bo->getName());
            if (conn2)
               conn2->setGUIColor(clRed);
         }
      }
      updateConnections();

      for (int i=0; i<=d_InspectorList->Count-1; i++)
         if (d_InspectorList->Objects[i] == bo) {
            SendMessage(((TfrmObjectInspector*)StrToInt(d_InspectorList->Strings[i]))->Handle, smRefreshInspector, 0, 0);
            break;
         }

      if (frmCommandScriptViewer)
         GenerateCommandScript1Click(this);
   }

}




//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::SMInspectorClosedHandler(TMessage& msg)
{
   TfrmObjectInspector* oi = (TfrmObjectInspector*)msg.LParam;
   int idx = d_InspectorList->IndexOf(IntToStr((long)oi));
   if (idx >= 0)
      d_InspectorList->Delete(idx);
}



//---------------------------------------------------------------------------
void __fastcall TfrmTransactionEditor::GenerateCommandScript1Click(
      TObject *Sender)
{
   // do it!
   bool showit = Sender == GenerateCommandScript1;
   frmCommandScriptViewer = TfrmCommandScriptViewer::Instance(this, d_CurrentTransaction);
   TfrmCommandScriptViewer* csv = frmCommandScriptViewer;
   csv->MemoSource1->Lines->Clear();
   TStrings* strs = csv->MemoSource1->Lines;

   // look for "orphaned" text items (ones with no connections) here, and display them as comments.
   for (TTextObjectCollection::CI toi = d_CurrentTransaction->getTextObjects()->begin(); toi != d_CurrentTransaction->getTextObjects()->end(); ++toi)
      if (toi->second->getConnections()->size() == 0)
         toi->second->writeScriptCode(strs, 0);

   d_CurrentTransaction->writeScriptCode(strs);
   if (showit) {
      csv->Show();
      if (FormStorage1->StoredValues->Values["DockScriptViewer"]->Value) {
         csv->ManualDock(Panel4, NULL, alClient);
         TabControl1->BringToFront();
         Panel2->BringToFront();
         Panel3->BringToFront();
         Panel4->BringToFront();
         Panel5->BringToFront();
         csv->StatusBar1->Visible = false;
      }
   }
}
//---------------------------------------------------------------------------


void __fastcall TfrmTransactionEditor::SMRefreshConnectionsHandler(TMessage &msg)
{
   updateConnections();
}
void __fastcall TfrmTransactionEditor::SetBreakpoint1Click(TObject *Sender)
{
   SetBreakpoint1->Checked = !SetBreakpoint1->Checked;        
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::Panel4DockDrop(TObject *Sender,
      TDragDockObject *Source, int X, int Y)
{
   Panel5->Visible = true;
   FormStorage1->StoredValues->Values["DockScriptViewer"]->Value = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::Panel4UnDock(TObject *Sender,
      TControl *Client, TWinControl *NewTarget, bool &Allow)
{
   Panel5->Visible = false;
   FormStorage1->StoredValues->Values["DockScriptViewer"]->Value = false;
}
//---------------------------------------------------------------------------


void __fastcall TfrmTransactionEditor::SMCommandScriptViewerClosedHandler(TMessage& msg)
{
   Panel5->Visible = false;
}
void __fastcall TfrmTransactionEditor::KnurlyControl1MouseDown(
      TObject *Sender, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
   d_ResizeDrag = true;
   d_StartPoint = ScreenToClient(KnurlyControl1->ClientToScreen(Point(X, Y))).y;
   TabControl1->BringToFront();
   Panel2->BringToFront();
   Panel3->BringToFront();
   Panel4->BringToFront();
   Panel5->BringToFront();
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::KnurlyControl1MouseUp(
      TObject *Sender, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
   d_ResizeDrag = false;
}
//---------------------------------------------------------------------------


void __fastcall TfrmTransactionEditor::KnurlyControl1MouseMove(
      TObject *Sender, TShiftState Shift, int X, int Y)
{
   int newX = ScreenToClient(KnurlyControl1->ClientToScreen(Point(X, Y))).y;
   if (d_ResizeDrag && newX != d_StartPoint) {
      frmCommandScriptViewer->Height = frmCommandScriptViewer->Height - (newX - d_StartPoint);
      d_StartPoint = newX;
      d_JustMoved = true;
      StatusBar1->Top = Height;
   }
   else {
      if (X < (KnurlyControl1->Width / 2) - 8 || X > (KnurlyControl1->Width / 2) + 8)
         KnurlyControl1->Cursor = crVSplit;
      else
         KnurlyControl1->Cursor = crHandPoint;
   }
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::Panel4DockOver(TObject *Sender,
      TDragDockObject *Source, int X, int Y, TDragState State,
      bool &Accept)
{
   Accept = Source->Control->ClassNameIs("TfrmCommandScriptViewer");
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::Panel2DockOver(TObject *Sender,
      TDragDockObject *Source, int X, int Y, TDragState State,
      bool &Accept)
{
   Accept = Source->Control->ClassNameIs("TfrmObjectToolbar");        
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::KnurlyControl1Click(TObject *Sender)
{
   if (d_JustMoved) {
      d_JustMoved = false;
      return;
   }
   if (KnurlyControl1->ArrowDirection == adUp) {
      frmCommandScriptViewer->Height = ClientHeight - Panel5->Height - TabControl1->Height - StatusBar1->Height;
      StatusBar1->Top = Height;
      KnurlyControl1->ArrowDirection = adDown;
   }
   else {
      frmCommandScriptViewer->Height = 30;
      KnurlyControl1->ArrowDirection = adUp;
   }
}
//---------------------------------------------------------------------------

void __fastcall TfrmTransactionEditor::FormResize(TObject *Sender)
{
//   for (int i=0; i<=ComponentCount-1; i++) {
//      TComponent* comp = Components[i];
//      if (comp->ClassNameIs("TAdvPanel") || comp->ClassNameIs("TkaiConnector"))
 //        dynamic_cast<TControl*>(comp)->SendToBack();
  // }
   TabControl1->BringToFront();
   Panel2->BringToFront();
   Panel3->BringToFront();
   Panel4->BringToFront();
   Panel5->BringToFront();
}
//---------------------------------------------------------------------------


void __fastcall TfrmTransactionEditor::SMColorChangedHandler(TMessage& msg)
{
   ScrollBox1->Color = ((TColor)msg.WParam);
}


void __fastcall TfrmTransactionEditor::SMUpdateStatusBarROHandler(TMessage& msg)
{
   if (msg.WParam)
      StatusBar1->SimpleText = "Read-Only Area";
   else
      StatusBar1->SimpleText = "";
}


void __fastcall TfrmTransactionEditor::SMUpdateInspectorHandler(TMessage& msg)
{
   for (int i=0; i<=d_InspectorList->Count-1; i++)
      try {
         SendMessage(reinterpret_cast<TForm*>(StrToInt(d_InspectorList->Strings[i]))->Handle, smUpdateContents, msg.WParam, msg.LParam);
      }
      catch (...) { }
      frmCommandScriptViewer->SetFocus();
}

void __fastcall TfrmTransactionEditor::SMUpdateBOConnectionsHandler(TMessage& msg)
{
   bool updateConns = false;
   for (TBusinessObjectCollection::CI boi = d_CurrentTransaction->getBusinessObjects()->begin(); boi != d_CurrentTransaction->getBusinessObjects()->end(); ++ boi) {
         TColor color = clLime;
         bool mappingfound = false;
         for (TBusinessObjectFieldCollection::CI bofi = boi->second->getFields()->begin();
                                                 bofi != boi->second->getFields()->end();
                                                 ++bofi) {
            if (!bofi->second->getMapping().Length())
               color = clRed;
            else
               mappingfound = true;
         }
         if (!mappingfound)
            color = clSilver;
         bool colorchanged = false;
         for (TConnectionCollection::CI cci = boi->second->getConnections()->begin(); cci != boi->second->getConnections()->end(); ++cci) {

            if (!cci->second->getOtherEnd()->ClassNameIs("TConnector"))
               continue;

            if (cci->second->getDirection() == cdOutbound)
               if (!mappingfound)
                  color = clRed;

            TConnection* conn1 = cci->second;
            TConnection* conn2 = cci->second->getOtherEnd()->getConnections()->findName(boi->second->getName());
            if (conn2 && conn1->getGUIColor() != color) {
               conn1->setGUIColor(color);
               conn2->setGUIColor(color);
               colorchanged = true;
            }
         }
         if (colorchanged)
            updateConns = true;
   }
   if (updateConns)
      SendMessage(this->Handle, smRefreshConnections, 0, 0);
}

void __fastcall TfrmTransactionEditor::SMTransactionNameChangedHandler(TMessage& msg)
{
   TabControl1->Tabs->Strings[TabControl1->TabIndex] = d_CurrentTransaction->getName();
   Caption = "Business Process Modeller - " + d_CurrentTransaction->getName();
}



