//---------------------------------------------------------------------------

#ifndef UITransactionEditorH
#define UITransactionEditorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
#include "OBJPersistentEx.h"
#include "OBJSystemMessages.h"
#include "kaiConnection.hpp"
#include "ElPanel.hpp"
#include "advpanel.hpp"
#include <ImgList.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include "ElPopBtn.hpp"
#include <AppEvnts.hpp>
#include <Buttons.hpp>
#include "Placemnt.hpp"
#include "KnurlyControl.h"
#include "ElPanel.hpp"
#include "ElPanel.hpp"

class TConnectableObject;
class TfrmCommandScriptViewer;

class TfrmTransactionEditor : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel2;
        TPanel *Panel1;
        TPanel *Panel3;
        TTabControl *TabControl1;
        TImage *Image1;
        TImage *Image2;
        TPopupMenu *PopupMenu1;
        TMenuItem *N1;
        TMenuItem *Configure1;
        TImage *pushclosedImageBlue;
        TImage *pushclosedImageRed;
        TImage *pushopenImageBlue;
        TImage *pushopenImageRed;
        TApplicationEvents *ApplicationEvents1;
        TMenuItem *DeleteConnection1;
        TImage *Image3;
        TMenuItem *GenerateCommandScript1;
        TImage *Image4;
        TMenuItem *SetBreakpoint1;
        TMenuItem *N2;
        TPanel *Panel4;
        TPanel *Panel5;
        TKnurlyControl *KnurlyControl1;
        TFormStorage *FormStorage1;
        TElPanel *ScrollBox1;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Panel3MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall Panel3MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Panel3MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall TabControl1Change(TObject *Sender);
        void __fastcall TabControl1Changing(TObject *Sender,
          bool &AllowChange);
        void __fastcall Properties1Click(TObject *Sender);
        void __fastcall Memo1Change(TObject *Sender);
        void __fastcall ApplicationEvents1Hint(TObject *Sender);
        void __fastcall FormContextPopup(TObject *Sender, TPoint &MousePos,
          bool &Handled);
        void __fastcall DeleteConnection1Click(TObject *Sender);
        void __fastcall GenerateCommandScript1Click(TObject *Sender);
        void __fastcall SetBreakpoint1Click(TObject *Sender);
        void __fastcall Panel4DockDrop(TObject *Sender,
          TDragDockObject *Source, int X, int Y);
        void __fastcall Panel4UnDock(TObject *Sender, TControl *Client,
          TWinControl *NewTarget, bool &Allow);
        void __fastcall KnurlyControl1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall KnurlyControl1MouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall KnurlyControl1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall Panel4DockOver(TObject *Sender,
          TDragDockObject *Source, int X, int Y, TDragState State,
          bool &Accept);
        void __fastcall Panel2DockOver(TObject *Sender,
          TDragDockObject *Source, int X, int Y, TDragState State,
          bool &Accept);
        void __fastcall KnurlyControl1Click(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
private:	// User declarations
        int d_X, d_Y;
        int d_StartPoint;
        bool d_Dragging;
        TRect d_Rect;
        TPoint d_Start, d_End;
        TConnectableObject* d_SourceObject;
        TAdvPanel* d_SourcePanel;
        TTransaction* d_CurrentTransaction;
        TConnectableObject* d_CurrentObject;
        TkaiConnector* d_CurrentConnection;
        bool d_ForcedConnectionBtnDown;
        int d_SavedDownButtonIdx;
        bool d_ResizeDrag;
        bool d_ProcessingDrag;
        bool d_JustMoved;
        String __fastcall getAvailableUnnamedID(TStrings* list, const String& prefix);
        TAdvPanel* d_CurrentPanel;
        TStringList* d_InspectorList;

        TAdvPanel* __fastcall insertPanel(TColor color, TConnectableObject* pe, TImage* image);
        TAdvPanel* __fastcall findPanel(TConnectableObject* co);
        void __fastcall drawConnection(TConnection* co, TAdvPanel* pnl1, TAdvPanel* pnl2, TColor color);
        void __fastcall positionPanel(TAdvPanel* pnl, int left, int top, int width, int height);
        void __fastcall AdvPanelResize(TObject *Sender);
        void __fastcall AdvPanelClose(TObject *Sender);
        void __fastcall BusinessObjectDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
        void __fastcall BusinessObjectDragDrop(TObject *Sender,
              TObject *Source, int X, int Y);
        void __fastcall cbConnectorChanged(TObject *Sender);
        void __fastcall AdvPanelContextPopup(TObject *Sender, const TPoint &MousePos, bool &Handled);
        void __fastcall ConnectionContextPopup(TObject *Sender, const TPoint &MousePos, bool &Handled);
        void __fastcall AdvPanelDblClick(TObject *Sender);
        void __fastcall ControlMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall ControlMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ControlMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall memoBounce(TObject *Sender);
        void __fastcall PushBtnClick(TObject *Sender);
        void __fastcall drawLine();
        void __fastcall updateConnections();

        void __fastcall SMAddTransactionHandler(TMessage& msg);
        void __fastcall SMShowObjectToolboxHandler(TMessage& msg);
        void __fastcall SMObjectPropertiesChangedHandler(TMessage& msg);
        void __fastcall SMObjectNameChangedHandler(TMessage& msg);
        void __fastcall SMInspectorClosedHandler(TMessage& msg);
        void __fastcall SMRefreshConnectionsHandler(TMessage& msg);
        void __fastcall SMCommandScriptViewerClosedHandler(TMessage& msg);
        void __fastcall SMColorChangedHandler(TMessage& msg);
        void __fastcall SMDeleteCompHandler(TMessage& msg);
        void __fastcall SMUpdateStatusBarROHandler(TMessage& msg);
        void __fastcall SMUpdateInspectorHandler(TMessage& msg);
        void __fastcall SMUpdateBOConnectionsHandler(TMessage& msg);
        void __fastcall SMTransactionNameChangedHandler(TMessage& msg);
        BEGIN_MESSAGE_MAP
           MESSAGE_HANDLER(smAddTransaction, TMessage, SMAddTransactionHandler);
           MESSAGE_HANDLER(smShowObjectToolbox, TMessage, SMShowObjectToolboxHandler);
           MESSAGE_HANDLER(smObjectPropertiesChanged, TMessage, SMObjectPropertiesChangedHandler);
           MESSAGE_HANDLER(smObjectNameChanged, TMessage, SMObjectNameChangedHandler);
           MESSAGE_HANDLER(smInspectorClosed, TMessage, SMInspectorClosedHandler);
           MESSAGE_HANDLER(smRefreshConnections, TMessage, SMRefreshConnectionsHandler);
           MESSAGE_HANDLER(smCommandScriptViewerClosed, TMessage, SMCommandScriptViewerClosedHandler);
           MESSAGE_HANDLER(smColorChanged, TMessage, SMColorChangedHandler);
           MESSAGE_HANDLER(smDeleteComp, TMessage, SMDeleteCompHandler);
           MESSAGE_HANDLER(smUpdateStatusBarRO, TMessage, SMUpdateStatusBarROHandler);
           MESSAGE_HANDLER(smUpdateInspector, TMessage, SMUpdateInspectorHandler);
           MESSAGE_HANDLER(smUpdateBOConnections, TMessage, SMUpdateBOConnectionsHandler);
           MESSAGE_HANDLER(smTransactionNameChanged, TMessage, SMTransactionNameChangedHandler);
        END_MESSAGE_MAP(TForm);
protected:
        static TfrmTransactionEditor* _instance;
        __fastcall TfrmTransactionEditor(TComponent* Owner);
public:		// User declarations
        static TfrmTransactionEditor* Instance(TComponent* Owner);
        __fastcall ~TfrmTransactionEditor();
};


//---------------------------------------------------------------------------
#endif
