// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'kaiConnection.pas' rev: 5.00

#ifndef kaiConnectionHPP
#define kaiConnectionHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Kaiconnection
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TkaiConnectPoint { cpLeftTop, cpLeft, cpLeftBottom, cpBottom, cpRightBottom, cpRight, cpRightTop, 
	cpTop, cpAuto };
#pragma option pop

#pragma option push -b-
enum TkaiLineStyle { lsSolid, lsRoundDot, lsSquareDot, lsDash, lsDashDot, lsLongDash, lsLongDashDot, 
	lsLongDashDotDot };
#pragma option pop

#pragma option push -b-
enum TkaiArrowStyle { asNoArrow, asArrow, asOpenArrow, asStealthArrow, asDiamondArrow, asOvalArrow }
	;
#pragma option pop

class DELPHICLASS TkaiConnections;
class DELPHICLASS TkaiConnector;
class PASCALIMPLEMENTATION TkaiConnections : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FList;
	int __fastcall GetCount(void);
	TkaiConnector* __fastcall GetItem(int Index);
	
public:
	__fastcall TkaiConnections(void);
	__fastcall virtual ~TkaiConnections(void);
	void __fastcall Add(TkaiConnector* Value);
	void __fastcall Delete(TkaiConnector* Value);
	bool __fastcall Exists(TkaiConnector* Value);
	__property int Count = {read=GetCount, nodefault};
	__property TkaiConnector* Items[int Index] = {read=GetItem};
};


class DELPHICLASS TkaiArrows;
class PASCALIMPLEMENTATION TkaiArrows : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TkaiArrowStyle FBeginStyle;
	TkaiArrowStyle FEndStyle;
	int FBeginSize;
	int FEndSize;
	TkaiConnector* FConnection;
	void __fastcall SetBeginStyle(TkaiArrowStyle Value);
	void __fastcall SetEndStyle(TkaiArrowStyle Value);
	void __fastcall SetBeginSize(int Value);
	void __fastcall SetEndSize(int Value);
	
protected:
	__fastcall TkaiArrows(void);
	
__published:
	__property TkaiArrowStyle BeginStyle = {read=FBeginStyle, write=SetBeginStyle, default=0};
	__property int BeginSize = {read=FBeginSize, write=SetBeginSize, default=5};
	__property TkaiArrowStyle EndStyle = {read=FEndStyle, write=SetEndStyle, default=0};
	__property int EndSize = {read=FEndSize, write=SetEndSize, default=5};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TkaiArrows(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TkaiConnector : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	AnsiString FControl1;
	AnsiString FControl2;
	TkaiConnectPoint FConnectToControl1;
	TkaiConnectPoint FConnectToControl2;
	Windows::TPoint FP1;
	Windows::TPoint FP2;
	Graphics::TColor FLineColor;
	int FLineWidth;
	TkaiLineStyle FLineStyle;
	TkaiArrows* FArrows;
	void __fastcall SetControl1(AnsiString Value);
	void __fastcall SetControl2(AnsiString Value);
	void __fastcall SetConnectToControl1(TkaiConnectPoint Value);
	void __fastcall SetConnectToControl2(TkaiConnectPoint Value);
	void __fastcall UpdatePosition(void);
	HIDESBASE MESSAGE void __fastcall WMEraseBkGnd(Messages::TWMEraseBkgnd &Message);
	MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	void __fastcall SetLineColor(Graphics::TColor Value);
	void __fastcall SetLineWidth(int Value);
	Windows::TPoint __fastcall GetPosition(TkaiConnectPoint Mode, AnsiString Control1, AnsiString Control2
		, TkaiConnectPoint ConnectPoint1, TkaiConnectPoint ConnectPoint2, const Windows::TPoint &OldPoint)
		;
	Windows::TPoint __fastcall GetSelfPosition(TkaiConnectPoint ConnectPoint, TkaiConnectPoint DefPoint
		);
	void __fastcall SetLineStyle(TkaiLineStyle Value);
	void __fastcall SetArrows(TkaiArrows* Value);
	void __fastcall PaintLine(Graphics::TCanvas* ACanvas, const Windows::TPoint &P1, const Windows::TPoint 
		&P2, bool DrawBeginArrow, bool DrawEndArrow, AnsiString Text);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TkaiConnector(Classes::TComponent* AOwner);
	__fastcall virtual ~TkaiConnector(void);
	
__published:
	__property AnsiString Control1 = {read=FControl1, write=SetControl1};
	__property AnsiString Control2 = {read=FControl2, write=SetControl2};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, nodefault};
	__property int LineWidth = {read=FLineWidth, write=SetLineWidth, nodefault};
	__property TkaiLineStyle LineStyle = {read=FLineStyle, write=SetLineStyle, default=0};
	__property TkaiConnectPoint ConnectToControl1 = {read=FConnectToControl1, write=SetConnectToControl1
		, default=8};
	__property TkaiConnectPoint ConnectToControl2 = {read=FConnectToControl2, write=SetConnectToControl2
		, default=8};
	__property TkaiArrows* Arrows = {read=FArrows, write=SetArrows};
	__property Caption ;
	__property Visible ;
	__property Font ;
	__property PopupMenu ;
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TkaiConnector(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE HHOOK WndProcHookHandle;
extern PACKAGE TkaiConnections* Connections;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Kaiconnection */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Kaiconnection;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// kaiConnection
